
#include "interface.h"
#include "bulanec.h"
#include "strela.h"
#include "prekazka.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "hraSa.h"
#include "ai.h"
 
void initAI()
{
	int i;

	for(i=0;armadaBulancov[i]!=NULL;i++)
		if(armadaBulancov[i]->jeAI==1)
		{
			int x,y,w,h;
			armadaBulancov[i]->zbran=PISTOL;
			armadaBulancov[i]->otoceny=0;
			armadaBulancov[i]->mozeStrielat=0;
			armadaBulancov[i]->nabijaSaZasobnik=0;
			armadaBulancov[i]->mrtvy=0;
			armadaBulancov[i]->bonus=BONUS_NIC;
			armadaBulancov[i]->casBonus=0;
			armadaBulancov[i]->mozePrehoditZbran=0;

			getRozmeryGrafika(armadaBulancov[i],&x,&y,&w,&h);


			armadaBulancov[i]->x=-1; armadaBulancov[i]->y=-1;
			volnyPriestor(&armadaBulancov[i]->x,&armadaBulancov[i]->y,
			BULANEC_SIRKA,BULANEC_VYSKA);
			armadaBulancov[i]->x+=BULANEC_SIRKA/2;
			armadaBulancov[i]->y+=BULANEC_VYSKA/2;
		}
	
}

int koliziaVsetko(bulanec *b,int px,int py)
{
		if(koliziaBulancov(b,px,py) ||
		 koliziaBulanecStena(b,px,py) ||
		 koliziaBulanecAnimacia(b,px,py) ||
		 koliziaBulanecTeleport(b,px,py) ||
		 koliziaBulanecTrubka(b,px,py) ||
		 koliziaBulanecRobot(b,px,py))
		{
			return 1;
		}

	return 0;
}

void chodNa(bulanec *b,int x,int y,int w,int h)
{
	int px=0,py=0;
	int smer=DOLE;

	if(b->x>x+w)px=-KROK;
	if(b->x<x)px=+KROK;
	if(b->y>y+h)py=-KROK;
	if(b->y<y)py=+KROK;

	if(px!=0 && py!=0)px=0;

	while(koliziaVsetko(b,px,0))
	{
		px=0;
		if(py==0)py=+KROK;
		goto sem;
	}

	while(koliziaVsetko(b,0,py))
	{
		py=0;
		if(px==0)px=+KROK;
	}

	sem:
	if(px!=0 && py!=0)px=0;

	if(py==-KROK)smer=HORE;
	if(px==+KROK)smer=VPRAVO;
	if(px==-KROK)smer=VLAVO;
	if(py==+KROK)smer=DOLE;
	
	//printf("smer=%d\n",smer);
	pohybBulanec(b,smer);
}

void chodNadostrel(bulanec *b,int x,int y,int w,int h)
{
	if(b->x>x && b->x<x+w)
	{
		if(b->y>y+h)b->otoceny=HORE;
		if(b->y<y)b->otoceny=DOLE;
		
		if(koliziaVsetko(b,0,0)==0)
		{
			if(b->naboje[PISTOL]>0)b->zbran=PISTOL;
			if(b->naboje[SAMOPAL]>0)b->zbran=SAMOPAL;
			if(b->naboje[BROKOVNICA]>0)b->zbran=BROKOVNICA;
			strielbaBulanec(b);
		}
	}

	if(b->y>y && b->y<y+h)
	{
		if(b->x>x+w)b->otoceny=VLAVO;
		if(b->x<x)b->otoceny=VPRAVO;

		if(koliziaVsetko(b,0,0)==0)
		{
			if(b->naboje[PISTOL]>0)b->zbran=PISTOL;
			if(b->naboje[SAMOPAL]>0)b->zbran=SAMOPAL;
			if(b->naboje[BROKOVNICA]>0)b->zbran=BROKOVNICA;
			strielbaBulanec(b);
		}
	}
}

void zabiTuxanca(bulanec *b,int active)
{
	int i;

	for(i=0;armadaBulancov[i]!=NULL;i++)
		if(armadaBulancov[i]->jeAI==0 && armadaBulancov[i]->mrtvy==0)
		{
			chodNadostrel(b,armadaBulancov[i]->x,armadaBulancov[i]->y,
			BULANEC_SIRKA,BULANEC_VYSKA);

			if(active)
			{
				chodNa(b,armadaBulancov[i]->x,armadaBulancov[i]->y,
				BULANEC_SIRKA,BULANEC_VYSKA);

				chodNadostrel(b,armadaBulancov[i]->x,armadaBulancov[i]->y,
				BULANEC_SIRKA,BULANEC_VYSKA);

				break;
			}
		}

}

void akciaAI(bulanec *b)
{
	if(b->mrtvy!=0)return;

	zabiTuxanca(b,0);

	if(zoznamVeci!=NULL && zoznamVeci->co!=MINA)
	{
		chodNa(b,zoznamVeci->x,zoznamVeci->y,
		zoznamVeci->w,zoznamVeci->h);
	}
	else
	{
		zabiTuxanca(b,1);
	}
}
