
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "animacia.h"

animacia *zoznamAnimacia;

void initAnimacia()
{
	zoznamAnimacia=NULL;
}

void pridajAnimacia(animacia **p,int px,int py,int pw,int ph,
		    SDL_Surface *pimg,int pmaxcas,int pactivePolicko,int pmaxpolicko,
		    int pvrstva,int pprechodna,int pactivePrechodna,int pkoniec)
{
	animacia *teraz;
	teraz = malloc(sizeof(animacia));

	teraz->x=px;
	teraz->y=py;
	teraz->w=pw;
	teraz->h=ph;
	teraz->image=pimg;
	teraz->cas=0;
	teraz->maxCas=pmaxcas;
	teraz->policko=0;
	teraz->activePolicko=pactivePolicko;
	teraz->maxPolicko=pmaxpolicko;
	teraz->vrstva=pvrstva;
	teraz->prechodna=pprechodna;
	teraz->activePrechodna=pactivePrechodna;
	teraz->koniec=pkoniec;
	
	teraz->next=*p;
	*p=teraz;
}

void kresliAnimacia(animacia **p)
{
	animacia *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		pridajImage(&zoznamImage,teraz->image,teraz->x,teraz->y,teraz->w,teraz->h,
		teraz->policko*teraz->w,0,teraz->w,teraz->h,teraz->vrstva,1);

		teraz=teraz->next;
	}
}

int koliziaBulanecAnimacia(bulanec *p,int px,int py)
{
	animacia *teraz;
	int x,y,w,h;

	teraz=zoznamAnimacia;
		
	getRozmery(p,&x,&y,&w,&h);
	x+=px;
	y+=py;
	
	while(teraz!=NULL)
	{
	
		if(teraz->policko<teraz->activePolicko)
		{
			if(p->bonus!=BONUS_DUCH && teraz->prechodna==0 && 
			   koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,teraz->w,teraz->h)==1)
			{
				return 1;
			}
		}
		else
		{
			if(p->bonus!=BONUS_DUCH && teraz->activePrechodna==0 && 
			   koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,teraz->w,teraz->h)==1)
			{
				return 1;
			}
		}

		teraz=teraz->next;
	}

	return 0;
}

int koliziaStrelaAnimacia()
{
	animacia *terazAnimacia;
	strela *terazStrela;
	strela *del;
	strela *pred;

	terazAnimacia=zoznamAnimacia;
	
	while(terazAnimacia!=NULL)
	{
		terazStrela=zoznamStrel;
		pred=NULL;

		while(terazStrela!=NULL)
		{
			if(terazStrela->prejde==0 && terazStrela->vidiet==0 &&
			   koliziaObdlznikov(terazAnimacia->x,terazAnimacia->y,
			   terazAnimacia->w,terazAnimacia->h,
			   terazStrela->x,terazStrela->y,
			   terazStrela->w,terazStrela->h))
			{
				if(terazAnimacia->policko<terazAnimacia->activePolicko)
				{
					terazAnimacia->policko=terazAnimacia->activePolicko;
					terazAnimacia->cas=0;
				}

				if(terazStrela->typ==BOMB_BALL)
				{
					odrazBombBall(terazStrela);

					pred=terazStrela;
					terazStrela=terazStrela->next;
					continue;
				}

				if(pred!=NULL)
				{
					pred->next=terazStrela->next;
					del=terazStrela;
					terazStrela=terazStrela->next;
					free(del);
					continue;
				}
				else
				{
					del=zoznamStrel;
					zoznamStrel=zoznamStrel->next;
					free(del);
					terazStrela=terazStrela->next;
					continue;
				}
			}

			pred=terazStrela;
			terazStrela=terazStrela->next;
		}

		terazAnimacia=terazAnimacia->next;
	}

	return 0;
}

void akciaAnimacia(animacia **p)
{
	animacia *teraz;
	animacia *pred;
	animacia *del;

	teraz=*p;
	pred=NULL;

	while(teraz!=NULL)
	{
		teraz->cas++;

		if(teraz->cas==teraz->maxCas)
		{
			teraz->cas=0;
			teraz->policko++;
			if(teraz->policko==teraz->activePolicko)teraz->policko=0;

			if(teraz->policko==teraz->maxPolicko)
			{
				if(teraz->koniec==0)
				{
					teraz->policko=teraz->maxPolicko-1;
				}
				else
				{
					if(pred!=NULL)
					{
						pridajPrekresli(&zoznamPrekresli,teraz->x-10,teraz->y-10,teraz->w+20,teraz->h+20);
						pred->next=teraz->next;
						del=teraz;
						teraz=teraz->next;
						free(del);
						continue;
					}
					else
					{
						pridajPrekresli(&zoznamPrekresli,teraz->x-10,teraz->y-10,teraz->w+20,teraz->h+20);
						del=zoznamAnimacia;
						zoznamAnimacia=zoznamAnimacia->next;
						free(del);
						teraz=teraz->next;
						continue;
					}
				}
			}
		}

		pred=teraz;
		teraz=teraz->next;
	}
}

void quitAnimacia(animacia **p)
{
	animacia *teraz;
	animacia *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		SDL_FreeSurface(teraz->image);
		teraz=teraz->next;
		free(del);
	}

	*p=NULL;
}
 
