
#ifndef ANIMACIA_H

#define ANIMACIA_H

typedef struct s_animacia
{
	int x; //suranica animacie X
	int y; //suranica animacie Y
	int w; //sirka jedeho policka
	int h; //dlzka jedneho policka
	SDL_Surface *image; //obrazok, ktory sa animuje musi ist ako poicka filmu
	int cas; //citac casu
	int maxCas;//cas, za ktory sa zmeni pociko
	int policko;//policko , ktore je prave zobrazene
	int activePolicko;//policko od ktoreho sa zacina, ked sa animacia activuje
	int maxPolicko;//pocet policiek
	int vrstva; //vrstva na ktorej je animacia
	int prechodna; //je animacia prechodna ?
	int activePrechodna; //je animacia prechodna ked sa aktivuje ?
	int koniec; //animacia sa po ukonceni odstrani, alebo zamrzne
	struct s_animacia *next;
} animacia;

extern animacia *zoznamAnimacia;

extern void initAnimacia();

/*
 * Prida animaciu do zoznamu animacii **p
 * 
 * **p - zoznam animacii
 * px py - suradnice animacie
 * pw ph - rozmery animacie
 * *pimg - surfrace polickok animacie
 * pmaxcas - cas za ktory sa vymenia jedno policko animacie za druhe
 * pactivePolicko - policko od ktoreho sa bude zacinat animacia,
 * ak sa animacia aktivuje
 * pmaxpolicko - celkovy pocet policko animacie 
 * pvrstva -vrstva na ktorej je animacia
 * pprechodna - je animacia prechodna ked je neaktivne ?
 * pactiveprechodna - je animacia prechodna ked je aktivne ?
 * pkoniec - ma sa animaia ukoncit a uvolnit zo zonamu, alebo sa ma zaseknut ?
 */
extern void pridajAnimacia(animacia **p,int px,int py,int pw,int ph,
		    SDL_Surface *pimg,int pmaxcas,int pactivePolicko,int pmaxpolicko,
		    int pvrstva,int pprechodna,int pactivePrechodna,int pkoniec);

/*
 * Zistuje ci je kolzia medzi tuxancom *p a
 * animaciami ulozenej v pointeri na strukturu zoznamAnimacia.
 *
 * parametre:
 * *p - pointer na strukturu tuxanca
 * px py - hodnoty, ktore sa maju pricitat k suradnici tuxanca
 * (pouziva sa iba vo funkcii, suradnice ulozene v strukture sa nezmenia)
 *
 * navratova hodnota:
 * 0 - klzia nenastala
 * 1 - kolizia nastala
 */
extern int koliziaBulanecAnimacia(bulanec *p,int px,int py);

/*
 * Zistuje ci je kolzia medzi strelami ulozenymi v zoznamStitiel
 * a prekazkami ulozenymi v zozname zoznamAnimacia.
 * Ak strela narazi na animaciu, aktivuje ju.
 * (zacne sa vykonavat ina animacia, zmeni sa prechodnost)
 */
extern int koliziaStrelaAnimacia();

extern void kresliAnimacia(animacia **p);

/*
 *  Nastavuje dalsie policko animacie, podla toho ci je aktivna
 *  policko 0 az pactivePolicko-1 ak je neaktivna
 *  pactivePolicko az pmaxpolicko-1 ak aktivna
 */
extern void akciaAnimacia(animacia **p);

extern void quitAnimacia(animacia **p);

#endif
