
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "prekazka.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "zvuky.h"

#ifdef NET_MULTIPLAYER
#include "siet.h"
#endif

bulanec **armadaBulancov;

static SDL_Surface *g_bulanec8;
static SDL_Surface *g_bulanec6;
static SDL_Surface *g_bulanec4;
static SDL_Surface *g_bulanec2;
static SDL_Surface *g_kriz;

void initBulanec()
{
	g_bulanec8 = loadImage(PATH_IMAGE "tux1a.png",1);
	g_bulanec4 = loadImage(PATH_IMAGE "tux2a.png",1);
	g_bulanec6 = loadImage(PATH_IMAGE "tux4a.png",1);
	g_bulanec2 = loadImage(PATH_IMAGE "tux3a.png",1);
	g_kriz = loadImage(PATH_IMAGE "kriz.png",1);
}

void kresliBulanec(bulanec *s)
{
	int x,y,w,h;
	SDL_Surface *poloha=NULL;

	if(s->vidiet!=0)return;
	//Takovy smer neznam, nebudu ho kreslit, nejspis neznam jeho pozici
	if (s->otoceny == 0) return;

	getRozmeryGrafika(s,&x,&y,&w,&h);

	if(s->mrtvy==0)
	{
		switch(s->otoceny)
		{
			case HORE: poloha=g_bulanec8; break;
			case VPRAVO: poloha=g_bulanec6; break;
			case VLAVO: poloha=g_bulanec4; break;
			case DOLE: poloha=g_bulanec2; break;
		}

		pridajImage(&zoznamImage,poloha,x,y,
		GRAFIKA_BULANEC_SIRKA,GRAFIKA_BULANEC_VYSKA,
		GRAFIKA_BULANEC_SIRKA*(s->animaciaKrokov/POCET_KLIKNUTI_KLAVESY),0,
		GRAFIKA_BULANEC_SIRKA,GRAFIKA_BULANEC_VYSKA,1,1);
	}
	else
	{
		pridajPrekresli(&zoznamPrekresli,x,y,w,h);

		pridajImage(&zoznamImage,g_kriz,s->x-BULANEC_SIRKA/2,s->y-BULANEC_VYSKA/2,
		KRIZ_SIZE_X,KRIZ_SIZE_Y,0,0,KRIZ_SIZE_X,KRIZ_SIZE_Y,0,1);
	}
}

int koliziaBulancov(bulanec *p,int px,int py)
{
	int i;
	int x1,y1,w1,h1;
	int x2,y2,w2,h2;

	getRozmery(p,&x1,&y1,&w1,&h1);
	x1+=px;
	y1+=py;

	for(i=0;armadaBulancov[i]!=NULL;i++)
	{
		if(p!=armadaBulancov[i]/* && armadaBulancov[i]->mrtvy==0*/)
		{
			getRozmery(armadaBulancov[i],&x2,&y2,&w2,&h2);
			if(koliziaObdlznikov(x1,y1,w1,h1,x2,y2,w2,h2)==1)return 1;
		}
	}

	return 0;
}

int koliziaStrelaBulanec(bulanec *p)
{
	strela *teraz;
	strela *pred;
	strela *del;
	int pocet=0;
	int x,y,w,h;

	teraz=zoznamStrel;
	pred=NULL;
	
	getRozmery(p,&x,&y,&w,&h);

	while(teraz!=NULL)
	{
		if(teraz->autorStreli!=p && teraz->vidiet==0 && 
		    koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,
		    teraz->w,teraz->h))
		{
			if(p->bonus==BONUS_TELEPORT)
			{
				int x,y,w,h;
				
				getRozmery(p,&x,&y,&w,&h);
				pridajPrekresli(&zoznamPrekresli,
				x-GRAFIKA_BULANEC_SIRKA,y-GRAFIKA_BULANEC_VYSKA,
				w+GRAFIKA_BULANEC_SIRKA*2,h+GRAFIKA_BULANEC_VYSKA*2);

				p->x=SURADNICA_ZIADNA; p->y=SURADNICA_ZIADNA;
				volnyPriestor(&p->x,&p->y,BULANEC_SIRKA,BULANEC_VYSKA);
				p->x+=BULANEC_SIRKA/2;
				p->y+=BULANEC_VYSKA/2;

				pred=teraz;
				teraz=teraz->next;
				continue;
			}

			if(p->mrtvy==0 && p->vidiet==0)
			{
/*
				printf("teraz->autorStreli=%p\n",teraz->autorStreli);
				printf("tuxanec=%p\n",p);
*/
				p->mrtvy=1;
				zvysKolo();

				pridajZbran();

				if(p==armadaBulancov[ACTIVE_BULANEC1])
					armadaBulancov[ACTIVE_BULANEC2]->score++;
				if(p==armadaBulancov[ACTIVE_BULANEC2])
					armadaBulancov[ACTIVE_BULANEC1]->score++;

				if(teraz->typ==BOMB_BALL)
				{
					pridajAnimacia(&zoznamAnimacia,teraz->x-10,teraz->y-10,
					VYBUCH_SIZE_X,VYBUCH_SIZE_Y,
					loadImage(PATH_IMAGE "vybuch.png",1),3,0,10,1,0,0,1);
				}

				prehrajZvuk(ZVUK_SMRT);

				if(pred!=NULL)
				{
					pred->next=teraz->next;
					del=teraz;
					teraz=teraz->next;
					free(del);
					continue;
				}
				else
				{
					del=zoznamStrel;
					zoznamStrel=zoznamStrel->next;
					free(del);
					teraz=teraz->next;
					continue;
				}
			}
		}

		pred=teraz;
		teraz=teraz->next;
		pocet++;
	}

	//printf("pocet=%d\n",pocet);
	return 0;
}

void akciaBulanec(bulanec *s)
{
	int x,y,w,h;
	int i;

	if(s->vidiet>0)s->vidiet--;
	if(s->mozeStrielat>0)s->mozeStrielat--;
	if(s->mozePrehoditZbran>0)s->mozePrehoditZbran--;

	if(s->casBonus>0)s->casBonus--;

	if(s->casBonus==0 && s->bonus!=BONUS_NIC)
	{
		int n=0;

		s->bonus=BONUS_NIC;
		
		if(koliziaBulanecStena(s,0,0)==0 &&
		   koliziaBulanecAnimacia(s,0,0)==0 &&
		   koliziaBulanecTrubka(s,0,0)==0 &&
		   koliziaBulanecRobot(s,0,0)==0)
		{
			n=1;
		}
		
		if(n==0)s->bonus=BONUS_DUCH;
	}

	if(s->naboje[PISTOL]==0 && s->naboje[SAMOPAL]==0 &&
	   s->naboje[BROKOVNICA]==0 && s->naboje[BOMBA]==0 &&
	   s->nabijaSaZasobnik>0)
	{
		s->nabijaSaZasobnik--;
		
		if(s->nabijaSaZasobnik==0)
		{
			s->zbran=PISTOL;
			s->naboje[PISTOL]=MAX_POCET_STRIEL;
			prehrajZvuk(ZVUK_NABYJA_SA);
		}
	}

	if(s->mrtvy>0)s->mrtvy++;
	
	if(s->mrtvy>=30)
	{
#ifdef NET_MULTIPLAYER
		if (stav == NONE || stav == SERVER){
#endif
			for(i=0;i<POCET_ZBRANI;i++)
				s->naboje[i]=0;

			s->naboje[PISTOL]=MAX_POCET_STRIEL;

			s->zbran=PISTOL;
			s->otoceny=VPRAVO;
			s->mozeStrielat=0;
			s->nabijaSaZasobnik=0;
			s->mrtvy=0;
			s->bonus=BONUS_NIC;
			s->casBonus=0;
			s->mozePrehoditZbran=0;

			getRozmeryGrafika(s,&x,&y,&w,&h);

			pridajPrekresli(&zoznamPrekresli,s->x-BULANEC_SIRKA/2,s->y-BULANEC_VYSKA/2,
			KRIZ_SIZE_X,KRIZ_SIZE_Y);

			s->x=-1; s->y=-1;
			volnyPriestor(&s->x,&s->y,BULANEC_SIRKA,BULANEC_VYSKA);
			s->x+=BULANEC_SIRKA/2;
			s->y+=BULANEC_VYSKA/2;

#ifdef NET_MULTIPLAYER
		}
		if (stav == SERVER) {
			char str[STR_SIZE];
			sprintf(str,"%d", s->id);
			sendEvent("breset", str);
			sprintf(str,"%d=%d %d %d",s->id, s->x, s->y, VPRAVO);
			sendEvent("setpos", str);
		}
#endif
	}	
}

void prehodZbran(bulanec *b)
{
	int i;

	for(i=b->zbran+1;i<POCET_ZBRANI;i++)
		if(b->naboje[i]>0)
		{
			b->zbran=i;
			return;
		}

	for(i=0;i<POCET_ZBRANI;i++)
		if(b->naboje[i]>0)
		{
			b->zbran=i;
			return;
		}
}

void pohybBulanec(bulanec *s,int smer)
{
#ifdef NET_MULTIPLAYER
	char str[STR_SIZE];
#endif

	if(smer != s->otoceny)
	{
		s->otoceny=smer;
		return;
	}

	s->animaciaKrokov++;
	if(s->animaciaKrokov==MAX_ANIMACIA*POCET_KLIKNUTI_KLAVESY)s->animaciaKrokov=0;

	switch(s->otoceny)
	{
		case HORE:
			if(s->y>0)s->y-=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
		case VPRAVO:
			if(s->x<HRACIA_PLOCHA_SIZE_X)s->x+=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
		case VLAVO:
			if(s->x>0)s->x-=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
		case DOLE:
			if(s->y<HRACIA_PLOCHA_SIZE_Y)s->y+=(s->bonus==BONUS_RYCHLOST?KROK*2:KROK);
		break;
	}

	zobrazZbran(&zoznamVeci,s);

#ifdef NET_MULTIPLAYER


//	if (s->local) 	//Todle pouziju az budu mit rozliseni lokalniho bulanka 
//	v bulanci strukture!
	if ((stav==CLIENT && s->id==1) || (stav==SERVER && s->id==0))
	{	
		s->sync--;
		if ((s->sync<0) || (s->sync>5)) {
			sprintf(str,"%d=%d %d %d",s->id,s->x,s->y,s->otoceny);
			sendEvent("setpos", str);
			s->sync = 5;
		}

		sprintf(str,"%d=%d", s->id, smer);
		sendEvent("bmove", str);
	}
#endif

}

void getRozmery(bulanec *p,int *x,int *y,int *w,int *h)
{
	*x=p->x-BULANEC_SIRKA/2;
	*y=p->y-BULANEC_VYSKA/2;
	*w=BULANEC_SIRKA;
	*h=BULANEC_VYSKA;
}

void getRozmeryGrafika(bulanec *p,int *x,int *y,int *w,int *h)
{
	*x=(p->x-BULANEC_SIRKA/2)+((BULANEC_SIRKA-GRAFIKA_BULANEC_SIRKA)/2);
	*y=(p->y-BULANEC_VYSKA/2)+(BULANEC_VYSKA-GRAFIKA_BULANEC_VYSKA);
	*w=GRAFIKA_BULANEC_SIRKA;
	*h=GRAFIKA_BULANEC_VYSKA;
}

bulanec* newBulanec(int x,int y,int f)
{
	bulanec *new;
	int i;

	new = malloc(sizeof(bulanec));
	new->x=x;
	new->y=y;
	new->farba=f;
	
	for(i=0;i<POCET_ZBRANI;i++)
		new->naboje[i]=0;

	new->naboje[PISTOL]=MAX_POCET_STRIEL;
	new->zbran=PISTOL;
	new->otoceny=VPRAVO;
	new->mozeStrielat=0;
	new->mrtvy=0;
	new->bonus=BONUS_NIC;
	new->casBonus=0;
	new->score=0;
	new->animaciaKrokov=0;
	new->nabijaSaZasobnik=0;
	new->mozePrehoditZbran=0;
	new->vidiet=0;
	new->jeAI=0;
	new->mutex = SDL_CreateMutex();

	return new;
}

void destroyBulanec(bulanec *s)
{
	SDL_DestroyMutex(s->mutex);
	free(s);
}

void quitBulanec()
{
	SDL_FreeSurface(g_bulanec8);
	SDL_FreeSurface(g_bulanec6);
	SDL_FreeSurface(g_bulanec4);
	SDL_FreeSurface(g_bulanec2);
	SDL_FreeSurface(g_kriz);
}
