
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "panel.h"
#include "strela.h"
#include "prekazka.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "nastavenia.h"
#include "tabulka.h"
#include "hudba.h"
#include "jazyk.h"
#include "ai.h"
#include "hraSa.h"
#include "suborLevel.h"

#ifdef NET_MULTIPLAYER
#include "siet.h"
#endif

//pozadie
static SDL_Surface *g_bg;

static SDL_Surface *g_pauza;

SDL_Surface **veciSurface;

static int kolo;
static int pauza;
static int casPauza;
static int casovacKoniec;

void initHraSa()
{	
	//Potrebuju ID kazde veci, ktera se bude pouzivat! Po siti se nedaji posilat pointery 
	//(resp. daji, ale je to k nicemu), takze musi mit vsechno cislo, nebo textove vyjadreni,..
	
	veciSurface = malloc(POCET_VECI * sizeof (void *));
	memset(veciSurface,0,POCET_VECI * sizeof (void *));

	veciSurface[PISTOL_DUAL] = loadImage(PATH_IMAGE "anim.ikonka.pistole-dual.png",1);
	veciSurface[BROKOVNICA] = loadImage(PATH_IMAGE "anim.ikonka.brokovnica.png",1);
	veciSurface[SAMOPAL] = loadImage(PATH_IMAGE "anim.ikonka.samopal.png",1);
	veciSurface[LASSER] = loadImage(PATH_IMAGE "anim.ikonka.lasergun.png",1);
	veciSurface[BOMBA] = loadImage(PATH_IMAGE "anim.ikonka.bomba.png",1);
	veciSurface[BOMB_BALL] = loadImage(PATH_IMAGE "anim.ikonka.bomb-ball.png",1);
	veciSurface[MINA] = loadImage(PATH_IMAGE "mina.png",1);

	veciSurface[BONUS_RYCHLOST] = loadImage(PATH_IMAGE "anim.bonus_rychlost.png",1);
	veciSurface[BONUS_NABOJE] = loadImage(PATH_IMAGE "anim.bonus_naboje.png",1);
	veciSurface[BONUS_4X] = loadImage(PATH_IMAGE "anim.bonus_4x.png",1);
	veciSurface[BONUS_TELEPORT] = loadImage(PATH_IMAGE "anim.bonus_teleport.png",1);
	veciSurface[BONUS_DUCH] = loadImage(PATH_IMAGE "anim.bonus_duch.png",1);

	switch(getJazyk())
	{
		case JAZYK_SK :
		case JAZYK_CZ :
			g_pauza = loadImage(PATH_IMAGE "pauza.sk-cz.png",1);
		break;
		case JAZYK_EN :
			g_pauza = loadImage(PATH_IMAGE "pauza.en.png",1);
		break;
	}
}

void setSmer(int smer,int *px,int *py)
{
	switch(smer)
	{
		case HORE:
			*px=0;
			*py=-1;
		break;
		case VPRAVO:
			*px=+1;
			*py=0;
		break;
		case VLAVO:
			*px=-1;
			*py=0;
		break;
		case DOLE:
			*px=0;
			*py=+1;
		break;
	}
}

int negujSmer(int n)
{
	switch(n)
	{
		case HORE:
			return DOLE;
		break;
		case VPRAVO:
			return VLAVO;
		break;
		case VLAVO:
			return VPRAVO;
		break;
		case DOLE:
			return HORE;
		break;
	}

	return -1;
}

int koliziaObdlznikov(int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2)
{
	return (x1<x2+w2 && x2<x1+w1 && y1<y2+h2 && y2<y1+h1);
}

void prehod(int *a,int *b)
{
	int z;

	z=*a;
	*a=*b;
	*b=z;
}

void zvysKolo()
{
	kolo++;
}

void kresliHraSa()
{
	SDL_Rect dst_rect;
	int i;

#ifdef NET_MULTIPLAYER
	SDL_LockMutex(mutex_display);
#endif

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(g_bg, NULL,screen, &dst_rect);
	
	for(i=0;armadaBulancov[i]!=NULL;i++)
		kresliBulanec(armadaBulancov[i]);

	kresliVec(&zoznamVeci);
	kresliTeleport(&zoznamTeleport);
	kresliTrubka(&zoznamTrubka);
	kresliStrela(&zoznamStrel);
	kresliPrekazka(&zoznamPrekazok);
	kresliAnimacia(&zoznamAnimacia);
	kresliRobot(&zoznamRobot);

	zoznamImageShow(&zoznamImage);

	if(pauza)
	{
		dst_rect.x = WINDOW_SIZE_X/2-PAUZA_SIZE_X/2;
		dst_rect.y = WINDOW_SIZE_Y/2-PAUZA_SIZE_Y/2;
		SDL_BlitSurface(g_pauza, NULL,screen, &dst_rect);
	}

	kresliPanel(armadaBulancov[ACTIVE_BULANEC1],armadaBulancov[ACTIVE_BULANEC2]);

#ifdef NET_MULTIPLAYER
	SDL_UnlockMutex(mutex_display);
#endif

}

void klavesaAkcia(bulanec *p,int s)
{
	int zal;
	int px,py;
	int mykrok;

#ifdef NET_MULTIPLAYER_OLD
	char str[STR_SIZE];
#endif

	if(pauza || p->mrtvy!=0 || p->vidiet!=0)return;	
	
	if(s!=STREL && p->otoceny!=s)
	{
		int x,y,w,h;
		getRozmeryGrafika(p,&x,&y,&w,&h);

		zal=p->otoceny;
		p->otoceny=s;
	
		if(koliziaBulanecStena(p,0,0)==1 ||
		   koliziaBulanecAnimacia(p,0,0)==1 ||
		   koliziaBulanecRobot(p,0,0)==1 ||
		   koliziaBulanecTrubka(p,0,0)==1)
		{
			p->otoceny=zal;
		}
		
		pridajPrekresli(&zoznamPrekresli,x,y,w,h);
		return;
	}

	switch(s)
	{
		case HORE :
		case VPRAVO :
		case VLAVO :
		case DOLE :
			setSmer(s,&px,&py);
			mykrok=(p->bonus==BONUS_RYCHLOST?KROK*2:KROK);

			if(koliziaBulanecStena(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulancov(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecRobot(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecAnimacia(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecTrubka(p,px*mykrok,py*mykrok)==0 &&
			   koliziaBulanecTeleport(p,px*mykrok,py*mykrok)==0)
			{
				pohybBulanec(p,s);
			}
		break;

		case STREL :
			strielbaBulanec(p);
		break;
	}
}

//Vystreli z bulankovy zbrane
void strielbaBulanec(bulanec *p)
{
	if(p->bonus==BONUS_DUCH && p->casBonus==0)return;

        if(p->mozeStrielat==0 && p->naboje[p->zbran]>0)
        {
#ifdef NET_MULTIPLAYER
		char str[STR_SIZE];
		sprintf(str,"%d",p->id);
		sendEvent("bshoot",str);
#endif
		if(p->zbran!=BOMBA)
		{
			if(p->bonus==BONUS_4X)
			{
				int zal;
				zal=p->otoceny;

				p->otoceny=HORE;
				pridajStrela(&zoznamStrel,p,p->zbran);
				p->otoceny=VPRAVO;
				pridajStrela(&zoznamStrel,p,p->zbran);
				p->otoceny=VLAVO;
				pridajStrela(&zoznamStrel,p,p->zbran);
				p->otoceny=DOLE;
				pridajStrela(&zoznamStrel,p,p->zbran);

				p->otoceny=zal;
			}
			else
			{
				pridajStrela(&zoznamStrel,p,p->zbran);
			}

			if(p->bonus!=BONUS_NABOJE)p->naboje[p->zbran]--;

		}
		else
		{
			pridajMinu(p);
		}

		koliziaStrelaBulanec(armadaBulancov[ACTIVE_BULANEC1]);
		
		if(armadaBulancov[ACTIVE_BULANEC2]!=NULL)
		koliziaStrelaBulanec(armadaBulancov[ACTIVE_BULANEC2]);
		
		if(p->zbran==BROKOVNICA)p->mozeStrielat=+40;
		else p->mozeStrielat=+10;

		if(p->naboje[p->zbran]==0)prehodZbran(p);
/*
		for(i=0;i<ZBRANI_CELKEM;i++)
			printf("%d\n",p->naboje[i]);
*/
		if(p->naboje[PISTOL]==0 && p->naboje[SAMOPAL]==0 &&
		   p->naboje[BROKOVNICA]==0 && p->naboje[BOMBA]==0)
		{
			p->zbran=PISTOL;
			p->nabijaSaZasobnik=100;
		}
	}
}

/* *************************************************************************** */

void klavesnica()
{
	Uint8 *mapa;
	mapa=SDL_GetKeyState(NULL);

	if(armadaBulancov[ACTIVE_BULANEC1]->mozePrehoditZbran==0 && 
	   (mapa[SDLK_KP1]==SDL_PRESSED || mapa[SDLK_RSHIFT]==SDL_PRESSED || mapa[SDLK_RALT]==SDL_PRESSED))
	{
		prehodZbran(armadaBulancov[ACTIVE_BULANEC1]);
		armadaBulancov[ACTIVE_BULANEC1]->mozePrehoditZbran=10;
	}

	if(mapa[SDLK_KP8]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],HORE);
	if(mapa[SDLK_KP6]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],VPRAVO);
	if(mapa[SDLK_KP4]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],VLAVO);
	if(mapa[SDLK_KP5]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],DOLE);
	if(mapa[SDLK_KP0]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],STREL);
	if(mapa[SDLK_RCTRL]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],STREL);

	if(mapa[SDLK_UP]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],HORE);
	if(mapa[SDLK_RIGHT]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],VPRAVO);
	if(mapa[SDLK_LEFT]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],VLAVO);
	if(mapa[SDLK_DOWN]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC1],DOLE);

	if(armadaBulancov[ACTIVE_BULANEC2]!=NULL)
	{
		if(mapa[SDLK_w]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],HORE);
		if(mapa[SDLK_d]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],VPRAVO);
		if(mapa[SDLK_a]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],VLAVO);
		if(mapa[SDLK_s]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],DOLE);
		if(mapa[SDLK_TAB]==SDL_PRESSED)klavesaAkcia(armadaBulancov[ACTIVE_BULANEC2],STREL);
		
		if(armadaBulancov[ACTIVE_BULANEC2]->mozePrehoditZbran==0 && 
		  mapa[SDLK_q]==SDL_PRESSED)
		{
			prehodZbran(armadaBulancov[ACTIVE_BULANEC2]);
			armadaBulancov[ACTIVE_BULANEC2]->mozePrehoditZbran=10;
		}
	}

	if(casPauza==0 && mapa[SDLK_p]==SDL_PRESSED)
	{
		if(pauza)pauza=0;
		else pauza=1;

		pridajPrekresli(&zoznamPrekresli,WINDOW_SIZE_X/2-PAUZA_SIZE_X/2,
		WINDOW_SIZE_Y/2-PAUZA_SIZE_Y/2,PAUZA_SIZE_X,PAUZA_SIZE_Y);

		casPauza=10;
	}
}

void akciaHraSa()
{
	int i,j;

	klavesnica();

	if(!pauza)
	{

		for(i=0;armadaBulancov[i]!=NULL;i++)
		{
			if(armadaBulancov[i]->jeAI)akciaAI(armadaBulancov[i]);
			akciaBulanec(armadaBulancov[i]);
		}

		for(i=0;i<2;i++)
		{
			akciaStrela(&zoznamStrel);
			
			for(j=0;armadaBulancov[j]!=NULL;j++)
				if(casovacKoniec==0)koliziaStrelaBulanec(armadaBulancov[j]);

			koliziaStrelaBombBall();
			koliziaStrelaTrubka();
			koliziaStrelaAnimacia();
			koliziaStrelaRobot();
			koliziaStrelaStena();
			koliziaStrelaTeleport();
		}

		akciaAnimacia(&zoznamAnimacia);
		akciaRobot(&zoznamRobot);
		akciaVec(&zoznamVeci);

	}

/*
	if(rand()%50==0)
	{
		pridajStrelaAnonymous(&zoznamStrel,
		BROKOVNICA,rand()&HRACIA_PLOCHA_SIZE_X,rand()&HRACIA_PLOCHA_SIZE_Y,
		(rand()%2==0?(rand()%2==0?VPRAVO:VLAVO):(rand()%2==0?HORE:DOLE)));
	}
*/
	if(casPauza>0)casPauza--;

	if(kolo>=getNastaveniaPocetKol())
	{
		casovacKoniec++;
		if(casovacKoniec>=CASOVAC_KONIEC_MAX)quitLevel();
	}
}

int isVolnyPriestor(int x,int y,int w,int h)
{
	int i;
	int xine,yine,wine,hine;

	prekazka *terazPrekazka;
	vec *terazVec;
	animacia *terazAnimacia;
	robot *terazRobot;
	teleport *terazTeleport;
	trubka *terazTrubka;
	
	for(i=0;armadaBulancov[i]!=NULL;i++)
	{
		getRozmery(armadaBulancov[i],&xine,&yine,&wine,&hine);

		if (armadaBulancov[i]->x!=SURADNICA_ZIADNA && 
		koliziaObdlznikov(x-10,y-10,w+20,h+20,xine,yine,wine,hine))return 0;
	}

	terazPrekazka=zoznamPrekazok;
	
	while(terazPrekazka!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazPrekazka->x,terazPrekazka->y,terazPrekazka->w,terazPrekazka->h))return 0;
	
		terazPrekazka=terazPrekazka->next;
	}

	terazVec=zoznamVeci;
	
	while(terazVec!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazVec->x,terazVec->y,terazVec->w,terazVec->h))return 0;
	
		terazVec=terazVec->next;
	}

	terazAnimacia=zoznamAnimacia;
	
	while(terazAnimacia!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		   terazAnimacia->x,terazAnimacia->y,terazAnimacia->w,terazAnimacia->h))return 0;

		terazAnimacia=terazAnimacia->next;
	}

	terazRobot=zoznamRobot;
	
	while(terazRobot!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		   terazRobot->x,terazRobot->y,terazRobot->w,terazRobot->h))return 0;

		terazRobot=terazRobot->next;
	}

	terazTeleport=zoznamTeleport;
	
	while(terazTeleport!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazTeleport->x,terazTeleport->y,terazTeleport->w,terazTeleport->h))return 0;

		terazTeleport=terazTeleport->next;
	}

	terazTrubka=zoznamTrubka;
	
	while(terazTrubka!=NULL)
	{
		if(koliziaObdlznikov(x-10,y-10,w+20,h+20,
		terazTrubka->x,terazTrubka->y,terazTrubka->w,terazTrubka->h))return 0;

		terazTrubka=terazTrubka->next;
	}

	return 1;
}

/*
void volnyPriestor(int *x,int *y,int w,int h)
{
	do{
		*x=rand()%(HRACIA_PLOCHA_SIZE_X-w);
		*y=rand()%(HRACIA_PLOCHA_SIZE_Y-(PANEL_SIZE_Y+h));
		printf("naohda %d %d\n",*x,*y);
	}while(isVolnyPriestor(*x,*y,w,h)==0);
}
*/

void volnyPriestor(int *x,int *y,int w,int h)
{
	int nx,ny;

	nx=*x;
	ny=*y;

	do{
		nx=rand()%(HRACIA_PLOCHA_SIZE_X-w);
		ny=rand()%(HRACIA_PLOCHA_SIZE_Y-(PANEL_SIZE_Y+h));
	}while(isVolnyPriestor(nx,ny,w,h)==0);

	*x=nx;
	*y=ny;
}

void pridajZbran()
{
#ifdef NET_MULTIPLAYER
	//V multiplayer modu vymejsli zbrane jenom server
	if (stav == CLIENT) return;
#endif
	int x,y,w,h;
	int co=0;
	int coPridam=0; //0-nic 1-zbran 2-bonus

	w=VEC_ZBRAN_SIZE_X;
	h=VEC_ZBRAN_SIZE_X;

	volnyPriestor(&x,&y,w,h);
	//pridajVec(&zoznamVeci,x,y,BONUS_RYCHLOST);

	if(isPovolenaNejakaZbran())coPridam=1;
	
	if(isPovolenyNejakyBonus())
	{
		if(coPridam==0)coPridam=2;
		else coPridam=(rand()%5==0?2:1);
	}

	if(coPridam==1)
	{
		do{
			switch(rand()%6+1)
			{
				case 1 : co=PISTOL_DUAL; break;
				case 2 : co=BROKOVNICA; break;
				case 3 : co=SAMOPAL; break;
				case 4 : co=LASSER; break;
				case 5 : co=BOMB_BALL; break;
				case 6 : co=BOMBA; break;
			}
		}while(getNastavenia(co)==0);
	}

	if(coPridam==2)
	{
		do{
			switch(rand()%5+1)
			{
				case 1 : co=BONUS_RYCHLOST; break;
				case 2 : co=BONUS_NABOJE; break;
				case 3 : co=BONUS_4X; break;
				case 4 : co=BONUS_TELEPORT; break;
				case 5 : co=BONUS_DUCH; break;
			}
		}while(getNastavenia(co)==0);
	}

	pridajVec(&zoznamVeci,x,y,co);
	pridajPrekresli(&zoznamPrekresli,x-10,y-10,w+20,h+20);
}

void pridajMinu(bulanec *p)
{
	int x,y;
	int w,h;
	int zalx,zaly;

	w=MINA_SIZE_X;
	h=MINA_SIZE_Y;
	x=p->x;
	y=p->y;

	switch(p->otoceny)
	{
		case HORE:
			y+=4+MINA_SIZE_Y;
		break;
		case VPRAVO:
			x-=20+MINA_SIZE_X;
		break;
		case VLAVO:
			x+=4+MINA_SIZE_X;
		break;
		case DOLE:
			y-=20+MINA_SIZE_Y;
		break;
	}

	zalx=p->x;
	zaly=p->y;
	p->x=SURADNICA_ZIADNA;
	p->y=SURADNICA_ZIADNA;

	if(isVolnyPriestor(x,y,w,h))
	{
		pridajVec(&zoznamVeci,x,y,MINA);
		pridajPrekresli(&zoznamPrekresli,x-10,y-10,w+20,h+20);
		p->naboje[BOMBA]--;
	}

	p->x=zalx;
	p->y=zaly;
}

/* *************************************************************************** */

void vytvorBulancov()
{
	armadaBulancov = malloc(4*sizeof(bulanec*));
	memset(armadaBulancov,0,4*sizeof(bulanec*));

	armadaBulancov[ACTIVE_BULANEC1]=newBulanec(0,0,0);
	volnyPriestor(&armadaBulancov[ACTIVE_BULANEC1]->x,&armadaBulancov[ACTIVE_BULANEC1]->y,
	BULANEC_SIRKA,BULANEC_VYSKA);
	armadaBulancov[ACTIVE_BULANEC1]->x+=BULANEC_SIRKA/2;
	armadaBulancov[ACTIVE_BULANEC1]->y+=BULANEC_VYSKA/2;

	printf("prvy tuxanec %d %d\n",
	armadaBulancov[ACTIVE_BULANEC1]->x,
	armadaBulancov[ACTIVE_BULANEC1]->y);

	if(getNastaveniaAI())
	{	
		armadaBulancov[ACTIVE_BULANEC2]=newBulanec(0,0,0);
		armadaBulancov[ACTIVE_BULANEC2]->jeAI=1;
	}
	else
	{
		armadaBulancov[ACTIVE_BULANEC2]=newBulanec(0,0,0);
		volnyPriestor(&armadaBulancov[ACTIVE_BULANEC2]->x,&armadaBulancov[ACTIVE_BULANEC2]->y,
		BULANEC_SIRKA,BULANEC_VYSKA);
		armadaBulancov[ACTIVE_BULANEC2]->x+=BULANEC_SIRKA/2;
		armadaBulancov[ACTIVE_BULANEC2]->y+=BULANEC_VYSKA/2;
		
		printf("druhy tuxanec %d %d\n",
		armadaBulancov[ACTIVE_BULANEC2]->x,
		armadaBulancov[ACTIVE_BULANEC2]->y);
	}

#ifdef NET_MULTIPLAYER
	if (stav==SERVER || stav==NONE) 
	{
		char str[STR_SIZE];
		int p = 0;
		if (stav==SERVER) {
			while (p != 1) {
				SDL_LockMutex(game.mutex);
				p = game.started;
				SDL_UnlockMutex(game.mutex);
				SDL_Delay(100);
			}

			sprintf(str,"0=%d %d %d", armadaBulancov[0]->x, armadaBulancov[0]->y, VPRAVO);
			sendEvent("setpos",str);
			sprintf(str,"1=%d %d %d", armadaBulancov[1]->x, armadaBulancov[1]->y, VPRAVO);
			sendEvent("setpos",str);
		}
	} else {
		//Vytvorim bulanky nekde, musim si pockat az mi server posle info kde maji byt
		armadaBulancov[ACTIVE_BULANEC1] = newBulanec(0,0,0);
		armadaBulancov[ACTIVE_BULANEC2] = newBulanec(0,0,0);
	}
#endif
	armadaBulancov[ACTIVE_BULANEC1]->id = 0;
	armadaBulancov[ACTIVE_BULANEC2]->id = 1;

	initAI();
}

void odstranBulancov()
{
	destroyBulanec(armadaBulancov[ACTIVE_BULANEC1]);
	if(armadaBulancov[ACTIVE_BULANEC2]!=NULL)destroyBulanec(armadaBulancov[ACTIVE_BULANEC2]);
	free(armadaBulancov);
}

void opisBulancov(int x1,int y1,int x2,int y2)
{
	kolo=0;
	armadaBulancov = malloc(3*sizeof(bulanec*));
	memset(armadaBulancov,0,3*sizeof(bulanec*));

	armadaBulancov[ACTIVE_BULANEC1]=newBulanec(x1,y1,0);
	armadaBulancov[ACTIVE_BULANEC1]=newBulanec(x2,y2,0);
	armadaBulancov[ACTIVE_BULANEC1]->id = 0; //doplnene, Oroborus

	armadaBulancov[ACTIVE_BULANEC2]=armadaBulancov[0];
	armadaBulancov[ACTIVE_BULANEC2]=armadaBulancov[1];
	armadaBulancov[ACTIVE_BULANEC2]->id = 1; //doplnene, Oroborus
}

/* *************************************************************************** */

void nacitajLevel(char **riadky)
{
	char *line;
	char cmd[STR_SIZE];
	char s_file[STR_SIZE];
	int a,b,c,d,e,f,g,h,i,j,k;
	int cisloRiadka;

	kolo=0;
	pauza=0;
	casPauza=0;
	casovacKoniec=0;

	initStrela();
	initPrekazka();
	initVec();
	initAnimacia();
	initRobot();
	initTeleport();
	initTrubka();

	
	for(cisloRiadka=0;riadky[cisloRiadka]!=NULL;cisloRiadka++)
	{
		line=(char *)riadky[cisloRiadka];

		if(strncmp(line,PRIKAZ_SETPLOCHA,PRIKAZ_SETPLOCHA_DLZKA)==0)
		{
			sscanf(line,"%s %s",cmd,s_file);			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			g_bg = loadImage(str,0);

			free(str);

			continue;
		}

		if(strncmp(line,PRIKAZ_ADD,PRIKAZ_ADD_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %d %d %s",
			       cmd,&a,&b,&c,&d,&f,&g,&h,&i,&j,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajPrekazku(&zoznamPrekazok,a,b,c,d,f,g,h,i,j,str);

			free(str);

			continue;
		}

		if(strncmp(line,PRIKAZ_ANIMACIA,PRIKAZ_ANIMACIA_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,&e,&f,&g,&h,&i,&j,&k,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajAnimacia(&zoznamAnimacia,a,b,c,d,loadImage(str,0),e,f,g,h,i,j,k);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_ROBOT,PRIKAZ_ROBOT_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,&e,&f,&g,&h,&i,&j,&k,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajRobot(&zoznamRobot,a,b,c,d,loadImage(str,0),e,f,g,h,i,j,k);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_TELEPORT,PRIKAZ_TELEPORT_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajTeleport(&zoznamTeleport,a,b,c,d,str);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_TRUBKA,PRIKAZ_TRUBKA_DLZKA)==0)
		{
			sscanf(line,"%s %d %d %d %d %d %d %d %s",
			       cmd,     &a,&b,&c,&d,&e,&f,&g,s_file);
			
			unsigned strl1 = strlen(PATH_IMAGE);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_IMAGE,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			pridajTrubka(&zoznamTrubka,a,b,c,d,e,f,g,str);
			free(str);
			continue;
		}

		if(strncmp(line,PRIKAZ_SETMUSIC,PRIKAZ_SETMUSIC_DLZKA)==0)
		{
			sscanf(line,"%s %s",
			       cmd,s_file);
			
			unsigned strl1 = strlen(PATH_MUSIC);
			unsigned strl2 = strlen(s_file);
			char * str = malloc(strl1+strl2+1);

			memcpy(str,PATH_MUSIC,strl1);
			memcpy(str+strl1,s_file,strl2+1);

			nacitajVlastnuHudbu(str);
			free(str);
			continue;
		}
	}

	vytvorBulancov();
	pridajZbran();
	prehrajHudbu(HUDBA_VLASTNA);
	//prehrajZvuk(ZVUK_OPENING);
}

void quitLevel()
{
	char meno1[STR_SIZE];
	char meno2[STR_SIZE];
	int co=0;

	getMena(meno1,meno2);

	nacitajTabulku();

	if(armadaBulancov[ACTIVE_BULANEC1]->score>
	   armadaBulancov[ACTIVE_BULANEC2]->score)
	{
		co=vlozDoTabulky(meno1,armadaBulancov[ACTIVE_BULANEC1]->score);
	}

	if(armadaBulancov[ACTIVE_BULANEC2]->score>
	   armadaBulancov[ACTIVE_BULANEC1]->score)
	{
		if(armadaBulancov[ACTIVE_BULANEC2]->jeAI==1)
			co=vlozDoTabulky(AI_NAME,armadaBulancov[ACTIVE_BULANEC2]->score);
		else
			co=vlozDoTabulky(meno2,armadaBulancov[ACTIVE_BULANEC2]->score);
	}

	ulozTabulku();
	odstranBulancov();

	quitStrela(&zoznamStrel);
	quitPrekazka(&zoznamPrekazok);
	quitVec(&zoznamVeci);
	quitAnimacia(&zoznamAnimacia);
	quitRobot(&zoznamRobot);
	quitTeleport(&zoznamTeleport);
	quitTrubka(&zoznamTrubka);

	SDL_FreeSurface(g_bg);

	setMiesto_v_hre((co==1?TABULKA:MAIN_MENU));
	uvolniVlastnuHudbu();
}

void quitHraSa()
{
	int i;
	/*
	 *  Ugly! Prvni zbran je pistol, ta nema svoji strukturu, ale v enumu je,
	 *  takze zacnu az za ni. Chtelo by to nejake lepsi reseni (strukturu pro 
	 *  kazdou zbran)
	 *
	 */

	for (i=0;i<POCET_VECI;i++) //opravene !!!
		if(veciSurface[i]!=NULL)SDL_FreeSurface(veciSurface[i]);
	
	free(veciSurface);
}
