
#ifndef HRA_SA_H

#define HRA_SA_H

#define ACTIVE_BULANEC1 0
#define ACTIVE_BULANEC2 1

#define PAUZA_SIZE_X 219
#define PAUZA_SIZE_Y 46

#define CASOVAC_KONIEC_MAX 100

/*
 * obsah:
 * inicialuzuje hru, nacita potrebnu grafiku animacii zbrani do premennych.
 * tato funkcia sa spusta prave raz na zaciatku programu.
 *
 * parametre:
 * -ziadne
 *
 * navratova hodnota:
 * -ziadna 
 */
extern void initHraSa();

/*
 * obsah:
 * funckia vracia opak smeru, ktory je parametrom
 *
 * parametre:
 * -parameter je makrokonstanta smer (HORE VPRAVO VLAVO alebo DOLE)
 *
 * navratova hodnota:
 * -opacny smer, ak parameter nemal hodnotu smeru tak -1 
 */
extern int negujSmer(int n);

/*
 * obsah:
 * funckia nastavuje na adresy px a py cisla, ktore
 * sa maju pripocitat aby siel objekt danym smerom
 *
 * parametre:
 * smer = smer podla ktoreho sa maju nastavit adresy px a py
 *         (HORE VPRAVO VLAVO alebo DOLE)
 * *px *py = adresy na ktore sa ulozia hodnoty.
 *
 * smer=HORE nastavi sa *px=0 *py=-1
 * smer=VPRAVO nastavi sa *px=+1 *py=0
 * smer=VLAVO nastavi sa *px=-1 *py=0
 * smer=DOLE nastavi sa *px=0 *py=+1
 *
 * navratova hodnota:
 * -ziadna 
 */
extern void setSmer(int smer,int *px,int *py);

/*
 * Zvyki pocet kol o jendo (kolo++)
 */
extern void zvysKolo();

extern void prehod(int *a,int *b);

/*
 * obsah:
 * Zistuje ci je obdznik so suradnicami x1 y1 sirkou w1 vyskou h1 v kolizi
 * s obdznikom na suradnici x2 y2 sirkou w2 a vyskou h2
 *
 * parametre:
 * x1  y1 - suradnice prveho obdlznika
 * w1  h1 - sirka a dlzka prveho obdlznika
 * x2  y2 - suradnice druheho obdlznika
 * w2  h2 - sirka a dlzka druheho obdlznika
 */
extern int koliziaObdlznikov(int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2);

/*
 * Zistuje stav klavesnice, pre multiplayer v jednom PC
 * a zalova funkcu klavesnicaAkcia.
 * venoval som tomu  tuto funkciu, inac by to bolo
 * v actionEvent()
 */
extern void klavesnica();

/*
 * Vykona akciu s bulancom
 * parametre:
 * *p - pointer na strukturu bulanca
 * s - akcia (konstanty pohybu alebo strela)
 */
extern void klavesaAkcia(bulanec *p,int s);

/*
 * Vystreli z bulankovy zbrane
 * parametre:
 * *p - pointer na strukturu bulanca
 */
extern void strielbaBulanec(bulanec *p);

/*
 * prekresli celu scenu scenu
 * tato funkcia sa vola iba vo funkcii kresli (interface.c)
 */
extern void kresliHraSa();

/*
 * akcia co sa ma preiodycky volat
 * kazdych 0.25 sekund
 * spusta casovace, ktore su ulozene vo funkciach
 * ktorych nazov sa zacina na akcia*
 */
extern void akciaHraSa();

/*
 * Nacita level ulozeny v subore *name
 */
extern void nacitajLevel(char **riadky);

/*
 * Uvolni prostriedky, ktore vznikli nacitanym levelu
 */
extern void quitLevel();

/*
 * Celkove ukonecnie hry.
 */
extern void quitHraSa();

/* 
 * Zistuje ci je volny priestor na suradnici x y
 * so sirkou a dlzkou w h
 */
extern int isVolnyPriestor(int x,int y,int w,int h);

/*
* do pointerov *x *y ulozi volne  pozicie na ploche,
* do ktorych sa zmesti objekt siroky w a vyskoy h pixlov
*/
extern void volnyPriestor(int *x,int *y,int w,int h);

/*
 * Prida predmet, do zoznamu *zoznamVeci
 * 1 k 5 ze to bude bonus inac to bude zbran
 */
extern void pridajZbran();

/*
 * Prida naslapnu minu do areny
 * pulanec, vhladom ne ktoreho sa mina
 * do areny dostane. Ak nie je volne miesto mina sa neprida
 */
extern void pridajMinu(bulanec *p);

/*
 * vytvori dvoch bulancov na nahodnom mieste na ktorom
 * nie su v kolizii s predmetmi. 
 */
extern void vytvorBulancov();

/*
 * vytvori dvoch bulancov na zadanych suradniciach
 */
extern void opisBulancov(int x1,int y1,int x2,int y2);

extern bulanec **armadaBulancov;
extern SDL_Surface **veciSurface;

#endif

