
#include "interface.h"
#include "hudba.h"

static Mix_Music *hudbaHlavneMenu;
static Mix_Music *hudbaVlastna;

static int zapnuta;
static int praveHra;

static Mix_Music* nacitajHudbu(char *s)
{
	Mix_Music *ret;

	if((ret = Mix_LoadMUS(s))==NULL)
	{
		fprintf(stderr,"Nepodarilo sa nacitat hudbu %s\n",s);
		return NULL;
	}

	return ret;
}

void initHudba()
{
	hudbaHlavneMenu = nacitajHudbu(PATH_MUSIC "bg-menu.ogg");
/*
	hudba2 = nacitajHudbu(PATH_MUSIC "bgl-na_dobru_noc.ogg");
	hudba3 = nacitajHudbu(PATH_MUSIC "bgl-nocna zmena.ogg");
	hudba4 = nacitajHudbu(PATH_MUSIC "bgl-v zajati 8-bit.ogg");
	hudba5 = nacitajHudbu(PATH_MUSIC "bgl-diskoteka.ogg");
*/
	zapnuta=1;
	praveHra=HUDBA_ZIADNA;
	hudbaVlastna=NULL;
}

void setHudbaStatus(int n)
{
	zapnuta=n;
	if(!zapnuta)skonciHudbu();
}

void nacitajVlastnuHudbu(char *s)
{
	hudbaVlastna=nacitajHudbu(s);
}

void uvolniVlastnuHudbu()
{
	Mix_FreeMusic(hudbaVlastna);
	hudbaVlastna=NULL;
}

void prehrajHudbu(int n)
{
	Mix_Music *hudba=NULL;
	
	if(praveHra==n)return;

	skonciHudbu();

	if(!zapnuta)return;
	
	switch(n)
	{
		case HUDBA_HLAVNE_MENU : hudba=hudbaHlavneMenu; break;
		case HUDBA_VLASTNA : hudba=hudbaVlastna; break;
	}

	if(hudba==NULL)
	{
		fprintf(stderr,"Nemozem prehrat hudobny zaznam !\n");
		return;
	}

	praveHra=n;
	Mix_PlayMusic(hudba,HUDBA_POCET_OPAKOVANI);
}

int getPraveHra()
{
	return praveHra;
}

void skonciHudbu()
{
	Mix_HaltMusic();
	praveHra=HUDBA_ZIADNA;
}

void quitHudba()
{
	Mix_FreeMusic(hudbaHlavneMenu);
} 
