
#include "interface.h"
#include "jazyk.h"

static char cesta[STR_SIZE];
static int statusJazyk;

char* Text(int ID)
{
	return Jazyk.Databaze[ID];
}

int kodJazyk()
{
       	FILE* Soubor;
	char home[STR_SIZE];

#ifdef WIN32
        sprintf(home, "%s/%s", getenv("USERPROFILE"), "Tuxanci");
#else
        sprintf(home, "%s/%s", getenv("HOME"), ".tuxanci");
#endif

        sprintf(cesta,"%s/language",home);

	if (access(cesta, F_OK)!=0)
	{
		printf("Language config file %s not found, creating new one...\n", cesta);
		if ((Soubor = fopen(cesta, "wt")) == NULL)
		{
			fprintf(stderr, "Can't create the file, quitting!\n");
			exit(0);
		}
		fprintf(Soubor, "en\n");
		fclose(Soubor);
	}

      	if((Soubor = fopen(cesta, "rt")) == NULL)
      	{
       		fprintf(stderr,"Can't load language config file %s!\n", cesta);
       		exit(0);
       	}

	fscanf(Soubor,"%s", Jazyk.Kod);
	printf("Language: %s\n", Jazyk.Kod);
	fclose(Soubor);

	if(strstr(Jazyk.Kod,"sk"))statusJazyk=JAZYK_SK;
	if(strstr(Jazyk.Kod,"cz"))statusJazyk=JAZYK_CZ;
	if(strstr(Jazyk.Kod,"en"))statusJazyk=JAZYK_EN;

	return 0;
}

void initJazyk()
{
	kodJazyk();
	
 	FILE* Soubor;
	char  cesta[STR_SIZE];
	int   veta, pismeno;

	// Nacteni spravneho jazykoveho souboru
	sprintf(cesta,"%s%s.lang", PATH_LANG, Jazyk.Kod);
	strcpy(Jazyk.Cesta, cesta);

	if((Soubor = fopen(cesta,"rt")) == NULL)
	{
            	fprintf(stderr,"Language file \"%s\" not found!\n",cesta);
            	exit(0);
	}

	// Cteni ze souboru
	for(veta = 0; veta < POCET_VET; veta++)
	{
	  	char Pismeno_;

 		for(pismeno = 0; ;pismeno ++)
          	{
                   	 Pismeno_ = fgetc(Soubor);

                   	 if(Pismeno_ == '\n' || Pismeno_ == EOF || !Pismeno_)break;
                   	 else Jazyk.Databaze[veta][pismeno] = Pismeno_;
                }
	}

	// Zavření souboru
	fclose(Soubor);
}

int getJazyk()
{
	return statusJazyk;
}

char* getJazykStr()
{
	return Jazyk.Kod;
}

void tabulkaJazyk()
{
	printf(" ======== String table ======== \n\n");
	printf(" Language:      %s \n", Jazyk.Kod);
	printf(" Language file: %s \n", Jazyk.Cesta);	
	int veta;
	for(veta = 0; veta < POCET_VET; veta++)
	{
		printf("%d  -  %s\n",veta, Text(veta));	
	}
	printf(" ============================== \n");
}

