
#include "interface.h"
#include "zbrane.h"
#include "widget_label.h"
#include "widget_button.h"
#include "widget_check.h"
#include "widget_textfield.h"
#include "bulanec.h"
#include "kurzor.h"
#include "panel.h"
#include "jazyk.h"
#include "zvuky.h"
#include "hudba.h"
#include "nastavenia.h"

static SDL_Surface *g_tapeta;

static wid_button *cudlikOk;

static wid_check *cudlik[POCET_VECI];
static wid_check *cudlikZvuky;
static wid_check *cudlikHudba;
static wid_check *cudlikAI;

static wid_label *napisZbrane;
static wid_label *napisBonusy;
static wid_label *napisPocetKol;
static wid_label *napisHracVpravo;
static wid_label *napisHracVlavo;
static wid_label *napisZvuky;
static wid_label *napisHudba;
static wid_label *napisAI;

static wid_textfield *pocetKolPis;
static wid_textfield *meno1;
static wid_textfield *meno2;

static int defaultPocetKol=DEFAULT_POCET_KOL;
static char cesta[STR_SIZE];

void initNastavenia()
{
	int i;
	char textik[STR_SIZE];
	char home[STR_SIZE];

#ifdef WIN32
	sprintf(home, "%s/%s", getenv("USERPROFILE"), "Tuxanci");
#else
	sprintf(home, "%s/%s", getenv("HOME"), ".tuxanci");
#endif

	sprintf(cesta,"%s/tuxanci.conf",home);

	g_tapeta = loadImage(PATH_IMAGE "vyber_level.png",0);
	cudlikOk = newButton(WINDOW_SIZE_X/2+BUTTON_SIZE_X,WINDOW_SIZE_Y-75,"Ok");
	
	memset(cudlik,0,POCET_VECI*sizeof(wid_check *));

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA)
		{
			if(i<=3)
			{
				cudlik[i]=newCheck(100-(CHECK_SIZE_X+10),100+50*i,CHECK_ANO);
			}
			else
			{
				cudlik[i]=newCheck(220-(CHECK_SIZE_X+10),100+50*(i-3),CHECK_ANO);
			}
		}

		if(i>=BONUS_RYCHLOST && i<=BONUS_DUCH)
		{
			cudlik[i]=newCheck((WINDOW_SIZE_X-150)-(CHECK_SIZE_X+10),
			100+50*(i-(BONUS_RYCHLOST-1)),CHECK_ANO);
		}
	}

	napisZbrane = newLabel(100-(CHECK_SIZE_X+10),120,LABEL_LEFT,Text(TEXT_ZBRANE));
	napisBonusy = newLabel((WINDOW_SIZE_X-150)-(CHECK_SIZE_X+10),120,LABEL_LEFT,Text(TEXT_BONUSY));
	napisPocetKol = newLabel(100-(CHECK_SIZE_X+10),WINDOW_SIZE_Y-190,LABEL_LEFT,Text(TEXT_POCET_KOL));
	napisHracVpravo = newLabel(100-(CHECK_SIZE_X+10),WINDOW_SIZE_Y-148,LABEL_LEFT,Text(TEXT_HRAC_VPRAVO));
	napisHracVlavo = newLabel(100-(CHECK_SIZE_X+10),WINDOW_SIZE_Y-106,LABEL_LEFT,Text(TEXT_HRAC_VLAVO));

	napisZvuky = newLabel(100-(CHECK_SIZE_X+10),WINDOW_SIZE_Y-69,LABEL_LEFT,Text(TEXT_HRAC_ZVUKY));
	napisHudba = newLabel(180,WINDOW_SIZE_Y-69,LABEL_LEFT,Text(TEXT_HRAC_HUDBA));
	napisAI = newLabel(300,WINDOW_SIZE_Y-69,LABEL_LEFT,"AI :"); //internacionalizmus

	cudlikZvuky = newCheck(140,WINDOW_SIZE_Y-69,CHECK_ANO);
	cudlikHudba = newCheck(250,WINDOW_SIZE_Y-69,CHECK_ANO);
	cudlikAI = newCheck(340,WINDOW_SIZE_Y-69,CHECK_NIE);

	pocetKolPis = newTextfield(150,WINDOW_SIZE_Y-190,"15");
	sprintf(textik, "%s%d",Text(TEXT_FIELD_HRAC), 1);
	meno1 = newTextfield(175,WINDOW_SIZE_Y-148,textik);
        sprintf(textik, "%s%d",Text(TEXT_FIELD_HRAC), 2);
	meno2 = newTextfield(175,WINDOW_SIZE_Y-106,textik);

	if(access(cesta,F_OK)!=0)ulozNastavenia();
	nacitajNastavenia();
}

void kresliNastavenia()
{
	SDL_Rect dst_rect;
	int i;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(g_tapeta,NULL,screen, &dst_rect);
	
	for(i=PISTOL_DUAL;i<=BOMBA;i++)
	{
		if(i<=3)
		{
			dst_rect.x = 100;
			dst_rect.y = 100+i*50;
		}
		else
		{
			dst_rect.x = 220;
			dst_rect.y = 100+(i-3)*50;
		}

		SDL_BlitSurface(getZbranImage(i),NULL,screen, &dst_rect);
	}

	for(i=BONUS_RYCHLOST;i<=BONUS_DUCH;i++)
	{
		dst_rect.x = WINDOW_SIZE_X-150; dst_rect.y = 100+50*(i-(BONUS_RYCHLOST-1));
		SDL_BlitSurface(getBonusImage(i),NULL,screen, &dst_rect);
	}

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA)kresliCheck(cudlik[i]);
		if(i>=BONUS_RYCHLOST && i<=BONUS_DUCH)kresliCheck(cudlik[i]);
	}

	kresliCheck(cudlikZvuky);
	kresliCheck(cudlikHudba);
	kresliCheck(cudlikAI);

	kresliLabel(napisZbrane);
	kresliLabel(napisBonusy);
	kresliLabel(napisPocetKol);
	kresliLabel(napisHracVpravo);
	if(getNastaveniaAI()==0)kresliLabel(napisHracVlavo);
	kresliLabel(napisZvuky);
	kresliLabel(napisHudba);
	kresliLabel(napisAI);

	kresliTextfield(pocetKolPis);
	kresliTextfield(meno1);
	if(getNastaveniaAI()==0)kresliTextfield(meno2);
	
	kresliButton(cudlikOk);
	kresliKurzor();

	pridajPrekresli(&zoznamPrekresli,0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);
}

void zmenNastavenia()
{
	defaultPocetKol=atoi(pocetKolPis->napis);
	if(defaultPocetKol==0)defaultPocetKol=15;
	setZvukyStatus(getStatus(cudlikZvuky));
	setHudbaStatus(getStatus(cudlikHudba));
}

void akciaNastavenia()
{
	int i;

	akciaButton();

	akciaTextfield(pocetKolPis);
	akciaTextfield(meno1);
	if(getNastaveniaAI()==0)akciaTextfield(meno2);

	if(isKlik(cudlikOk)==1)
	{
		zmenNastavenia();
		setMiesto_v_hre(MAIN_MENU);
	}

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA)akciaCheck(cudlik[i]);
		if(i>=BONUS_RYCHLOST && i<=BONUS_DUCH)akciaCheck(cudlik[i]);
	}

	akciaCheck(cudlikZvuky);
	akciaCheck(cudlikHudba);
	akciaCheck(cudlikAI);

	if(isZmenilStav(cudlikHudba))
	{
		zmenNastavenia();
		if(getStatus(cudlikHudba))prehrajHudbu(HUDBA_HLAVNE_MENU);
	}
}

int getNastavenia(int n)
{
	return getStatus(cudlik[n]);
}

int getNastaveniaPocetKol()
{
	return defaultPocetKol;
}

int getNastaveniaAI()
{
	return getStatus(cudlikAI);
}

int isPovolenyNejakyBonus()
{
	int i;

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=BONUS_RYCHLOST && i<=BONUS_DUCH && getNastavenia(i)==1)return 1;
	}

	return 0;
}

int isPovolenaNejakaZbran()
{
	int i;

	for(i=0;i<POCET_VECI;i++)
	{
		if(i>=PISTOL_DUAL && i<=BOMBA && getNastavenia(i)==1)return 1;
	}

	return 0;
}

void getMena(char *s1,char *s2)
{
	strcpy(s1,meno1->napis);
	strcpy(s2,meno2->napis);
}

static void odstranMriez(char *s)
{
	int i;
	int len;

	len=strlen(s);

	for(i=0;i<len;i++)
		if(s[i]=='#')s[i]='\0'; // :)
}

void nacitajNastavenia()
{
	FILE *file;
	char line[STR_SIZE];
	int i;

	if((file = fopen(cesta,"rt"))==NULL)
	{
		fprintf(stderr,"subor %s sa neda otvorit pre citanie!\n",cesta);
		return;
	}
	

	for(i=0;i<POCET_VECI;i++)
	{
		if(cudlik[i]!=NULL)
		{
			fgets(line,STR_SIZE-1,file);
			odstranMriez(line);
			sscanf(line,"%d",&cudlik[i]->status);
		}
	}

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",pocetKolPis->napis);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",meno1->napis);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%s",meno2->napis);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&cudlikZvuky->status);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&cudlikHudba->status);

	fgets(line,STR_SIZE-1,file);
	odstranMriez(line);
	sscanf(line,"%d",&cudlikAI->status);

	fclose(file);
}

void ulozNastavenia()
{
	FILE *file;
	char line[STR_SIZE];
	int i;

	if((file = fopen(cesta,"wt"))==NULL)
	{
		fprintf(stderr,"subor %s sa neda otvorit pre zapis!\n",cesta);
		return;
	}
	

	for(i=0;i<POCET_VECI;i++)
	{
		switch(i)
		{
			case PISTOL_DUAL : strcpy(line,"%d # mam pistol dual\n"); break;
			case BROKOVNICA : strcpy(line,"%d # mam brokovnicu\n"); break;
			case SAMOPAL : strcpy(line,"%d # mam samopal\n"); break;
			case LASSER : strcpy(line,"%d # mam lasser\n"); break;
			case BOMB_BALL : strcpy(line,"%d # mam bomb-ball\n"); break;
			case BOMBA : strcpy(line,"%d # mam miny\n"); break;
			case BONUS_RYCHLOST : strcpy(line,"%d # mam bonus rychlost\n"); break;
			case BONUS_NABOJE : strcpy(line,"%d # mam bonus naboje\n"); break;
			case BONUS_4X : strcpy(line,"%d # mam bonus 4X\n"); break;
			case BONUS_TELEPORT : strcpy(line,"%d # mam bonus teleport\n"); break;
			case BONUS_DUCH : strcpy(line,"%d # mam duch\n"); break;
		}

		if(cudlik[i]!=NULL)fprintf(file,line,getStatus(cudlik[i]));
	}

	fprintf(file,"%s # pocet kol\n",pocetKolPis->napis);
	fprintf(file,"%s # meno tuxanca vpravo\n",meno1->napis);
	fprintf(file,"%s # meno tuxanca vlavo\n",meno2->napis);
	fprintf(file,"%d # zvuky\n",getStatus(cudlikZvuky));
	fprintf(file,"%d # hudba\n",getStatus(cudlikHudba));
	fprintf(file,"%d # AI\n",getStatus(cudlikAI));

	fclose(file);
}

void quitNastavenia()
{
	int i;

	ulozNastavenia();

	SDL_FreeSurface(g_tapeta);

	for(i=0;i<POCET_VECI;i++)
	{
		if(cudlik[i]!=NULL)destroyCheck(cudlik[i]);
	}

	destroyCheck(cudlikZvuky);
	destroyCheck(cudlikHudba);
	destroyCheck(cudlikAI);

	destroyLabel(napisZbrane);
	destroyLabel(napisBonusy);
	destroyLabel(napisPocetKol);
	destroyLabel(napisHracVpravo);
	destroyLabel(napisHracVlavo);
	destroyLabel(napisZvuky);
	destroyLabel(napisHudba);
	destroyLabel(napisAI);

	destroyTextfield(pocetKolPis);
	destroyTextfield(meno1);
	destroyTextfield(meno2);

	destroyButton(cudlikOk);
}
