
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "panel.h"

static SDL_Surface *g_panel;
static SDL_Surface *g_naboj;
static SDL_Surface *g_bonus;
static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

static SDL_Surface *g_vec_pistol;
static SDL_Surface *g_vec_pistolDual;
static SDL_Surface *g_vec_brokovnica;
static SDL_Surface *g_vec_samopal;
static SDL_Surface *g_vec_lasser;
static SDL_Surface *g_vec_bombball;
static SDL_Surface *g_vec_bomba;
static SDL_Surface *g_vec_mina;

static SDL_Surface *g_vec_bonus_rychlost;
static SDL_Surface *g_vec_bonus_naboje;
static SDL_Surface *g_vec_bonus_4x;
static SDL_Surface *g_vec_bonus_teleport;
static SDL_Surface *g_vec_bonus_duch;


void initPanel()
{
	g_panel = loadImage(PATH_IMAGE "panel.png",1);
	g_naboj = loadImage(PATH_IMAGE "naboj.png",1);
	g_bonus = loadImage(PATH_IMAGE "cas_bonus.png",0);

	g_vec_pistol=loadImage(PATH_IMAGE "ikonka.pistole.png",1);
	g_vec_pistolDual=loadImage(PATH_IMAGE "ikonka.pistole-dual.png",1);
	g_vec_samopal=loadImage(PATH_IMAGE "ikonka.samopal.png",1);
	g_vec_brokovnica=loadImage(PATH_IMAGE "ikonka.brokovnica.png",1);
	g_vec_lasser=loadImage(PATH_IMAGE "ikonka.lasergun.png",1);
	g_vec_bomba=loadImage(PATH_IMAGE "ikonka.bomba.png",1);
	g_vec_bombball=loadImage(PATH_IMAGE "ikonka.bomb-ball.png",1);
	g_vec_mina=loadImage(PATH_IMAGE "mina.png",1);

	g_vec_bonus_rychlost=loadImage(PATH_IMAGE "bonus_rychlost.png",1);
	g_vec_bonus_naboje=loadImage(PATH_IMAGE "bonus_naboje.png",1);
	g_vec_bonus_4x=loadImage(PATH_IMAGE "bonus_4x.png",1);
	g_vec_bonus_teleport=loadImage(PATH_IMAGE "bonus_teleport.png",1);
	g_vec_bonus_duch=loadImage(PATH_IMAGE "bonus_duch.png",1);
}

SDL_Surface* getZbranImage(int x)
{
	switch(x)
	{
		case PISTOL : return g_vec_pistol; break;
		case PISTOL_DUAL : return g_vec_pistolDual; break;
		case BROKOVNICA : return g_vec_brokovnica; break;
		case SAMOPAL : return g_vec_samopal; break;
		case LASSER : return g_vec_lasser; break;
		case BOMB_BALL : return g_vec_bombball; break;
		case BOMBA : return g_vec_bomba; break;
	}

	return NULL;
}

SDL_Surface* getBonusImage(int x)
{
	switch(x)
	{
		case BONUS_RYCHLOST : return g_vec_bonus_rychlost; break;
		case BONUS_NABOJE : return g_vec_bonus_naboje; break;
		case BONUS_4X : return g_vec_bonus_4x; break;
		case BONUS_TELEPORT : return g_vec_bonus_teleport; break;
		case BONUS_DUCH : return g_vec_bonus_duch; break;
	}

	return NULL;
}

void kresliPanel(bulanec *b2,bulanec *b1)
{
	//SDL_BlitSurface([Surfrace obrazka],[suradnice casti obrazka a rozmery obrazka],
	//[Surfrace okna],[poloha obrazka v okne]);
	
	SDL_Rect src_rect, dst_rect;
	SDL_Surface *text;
	char str[STR_SIZE];
	int width;
	int i;
	
	dst_rect.x=PANEL_POLOHA_X;
	dst_rect.y=PANEL_POLOHA_Y;
	
	SDL_BlitSurface(g_panel,NULL,screen, &dst_rect);
	
	dst_rect.x=PANEL_ZBRAN_IMAGE_VPRAVO_X;
	dst_rect.y=PANEL_ZBRAN_IMAGE_VPRAVO_Y;
	SDL_BlitSurface(getZbranImage(b2->zbran),NULL,screen, &dst_rect);
	if(b2->bonus!=BONUS_NIC)
	{
		dst_rect.x=PANEL_GRAF_BONUS_VPRAVO_X;
		dst_rect.y=PANEL_GRAF_BONUS_VPRAVO_Y;

		src_rect.x=0;
		src_rect.y=0;
		src_rect.w=PANEL_GRAF_BONUS_SIZE_X;
		src_rect.h=PANEL_GRAF_BONUS_SIZE_Y;
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		src_rect.y=PANEL_GRAF_BONUS_SIZE_Y;
		src_rect.w=(b2->bonus==BONUS_NAVZDY?100:b2->casBonus/5);
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		dst_rect.x=PANEL_BONUS_IMAGE_VPRAVO_X;
		dst_rect.y=PANEL_BONUS_IMAGE_VPRAVO_Y;
		SDL_BlitSurface(getBonusImage(b2->bonus),NULL,screen, &dst_rect);
	}

	dst_rect.x=PANEL_ZBRAN_IMAGE_VLAVO_X;
	dst_rect.y=PANEL_ZBRAN_IMAGE_VLAVO_Y;
	SDL_BlitSurface(getZbranImage(b1->zbran),NULL,screen, &dst_rect);

	if(b1->bonus!=BONUS_NIC)
	{
		dst_rect.x=PANEL_GRAF_BONUS_VLAVO_X;
		dst_rect.y=PANEL_GRAF_BONUS_VLAVO_Y;

		src_rect.x=0;
		src_rect.y=0;
		src_rect.w=PANEL_GRAF_BONUS_SIZE_X;
		src_rect.h=PANEL_GRAF_BONUS_SIZE_Y;
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		src_rect.y=PANEL_GRAF_BONUS_SIZE_Y;
		src_rect.w=(b1->bonus==BONUS_NAVZDY?100:b1->casBonus/5);
		SDL_BlitSurface(g_bonus,&src_rect,screen, &dst_rect);

		dst_rect.x=PANEL_BONUS_IMAGE_VLAVO_X;
		dst_rect.y=PANEL_BONUS_IMAGE_VLAVO_Y;
		SDL_BlitSurface(getBonusImage(b1->bonus),NULL,screen, &dst_rect);
	}

	src_rect.w=4;
	src_rect.h=8;
	src_rect.y=0;
	for(i=0;i<5;i++)
	{
		if(b1->naboje[b1->zbran]==0)break;

		if(b1->naboje[b1->zbran]>=i+1)src_rect.x=0;
		else src_rect.x=4;

		dst_rect.x = 20+5*i;
		dst_rect.y = (WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}

	src_rect.x=8;
	for(i=0;b1->nabijaSaZasobnik>0 && i<(100-b1->nabijaSaZasobnik)/10;i++)
	{
		dst_rect.x=9+4*i;
		dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}
	
	if(b2==NULL)return;

	for(i=0;i<5;i++)
	{
		if(b2->naboje[b2->zbran]==0)break;

		if(b2->naboje[b2->zbran]>=i+1)src_rect.x=0;
		else src_rect.x=4;

		dst_rect.x = WINDOW_SIZE_X+5*i-43;
		dst_rect.y = (WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}

	src_rect.x=8;
	for(i=0;b2->nabijaSaZasobnik>0 && i<(100-b2->nabijaSaZasobnik)/10;i++)
	{
		dst_rect.x=WINDOW_SIZE_X+4*i-50;
		dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+PANEL_SIZE_Y-20;
		SDL_BlitSurface(g_naboj,&src_rect,screen, &dst_rect);
	}

	pridajPrekresli(&zoznamPrekresli,0,(WINDOW_SIZE_Y-PANEL_SIZE_Y),PANEL_SIZE_X,PANEL_SIZE_Y);
/*	
	pridajPrekresli(&zoznamPrekresli,0,(WINDOW_SIZE_Y-PANEL_SIZE_Y),50,50);
	pridajPrekresli(&zoznamPrekresli,WINDOW_SIZE_X-50,(WINDOW_SIZE_Y-PANEL_SIZE_Y),50,50);
*/
	sprintf(str,"%d : %d",b1->score,b2->score);
	TTF_SizeText(g_font,str,&width,NULL);
	text = TTF_RenderUTF8_Blended(g_font,str,farba_pisma);
	dst_rect.x=WINDOW_SIZE_X/2-width/2;
#ifdef WIN32
	dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+17;
#else
	dst_rect.y=(WINDOW_SIZE_Y-PANEL_SIZE_Y)+20; // pro helba - upravit
#endif
	SDL_BlitSurface(text,NULL,screen,&dst_rect);
	SDL_FreeSurface(text);

}

void quitPanel()
{
	SDL_FreeSurface(g_panel);
	SDL_FreeSurface(g_naboj);
	SDL_FreeSurface(g_bonus);

	SDL_FreeSurface(g_vec_samopal);
	SDL_FreeSurface(g_vec_brokovnica);
	SDL_FreeSurface(g_vec_bomba);
	SDL_FreeSurface(g_vec_mina);
	SDL_FreeSurface(g_vec_pistol);

	SDL_FreeSurface(g_vec_bonus_rychlost);
	SDL_FreeSurface(g_vec_bonus_naboje);
	SDL_FreeSurface(g_vec_bonus_4x);
	SDL_FreeSurface(g_vec_bonus_teleport);
	SDL_FreeSurface(g_vec_bonus_duch);
}

