
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "prekazka.h"

prekazka *zoznamPrekazok;

//static SDL_Surface *g_strela;

void initPrekazka()
{
	zoznamPrekazok=NULL;
}

void pridajPrekazku(prekazka **p,int x,int y,int w,int h,int ix,int iy,int iw,int ih,int n,char *s)
{
	prekazka *teraz;

	teraz=malloc(sizeof(prekazka));
	teraz->x=x;
	teraz->y=y;
	teraz->img_x=ix;
	teraz->img_y=iy;
	teraz->img_w=iw;
	teraz->img_h=ih;
	teraz->w=w;
	teraz->h=h;
	teraz->vrstva=n;
	teraz->g=loadImage(s,1);
	teraz->next=*p;
	*p=teraz;
}

void kresliPrekazka(prekazka **p)
{
	prekazka *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		pridajImage(&zoznamImage,teraz->g,teraz->img_x,teraz->img_y,
		teraz->img_w,teraz->img_h,0,0,teraz->img_w,teraz->img_h,teraz->vrstva,0);

		teraz=teraz->next;
	}
}

int koliziaBulanecStena(bulanec *p,int px,int py)
{
	prekazka *teraz;
	int x,y,w,h;

	teraz=zoznamPrekazok;
		
	getRozmery(p,&x,&y,&w,&h);
	x+=px;
	y+=py;
	
	while(teraz!=NULL)
	{

		if(p->bonus!=BONUS_DUCH && teraz->x!=SURADNICA_ZIADNA && koliziaObdlznikov(x,y,w,h,
		   teraz->x,teraz->y,teraz->w,teraz->h)==1)return 1;

		teraz=teraz->next;
	}

	return 0;
}

int koliziaStrelaStena()
{
	prekazka *terazPrekazka;
	strela *terazStrela;
	strela *del;
	strela *pred;

	terazPrekazka=zoznamPrekazok;
	
	while(terazPrekazka!=NULL)
	{
		terazStrela=zoznamStrel;
		pred=NULL;

		while(terazStrela!=NULL)
		{
			if(terazStrela->prejde==0 && terazPrekazka->x!=SURADNICA_ZIADNA && 
			   koliziaObdlznikov(terazPrekazka->x,terazPrekazka->y,
			   terazPrekazka->w,terazPrekazka->h,
			   terazStrela->x,terazStrela->y,
			   terazStrela->w,terazStrela->h))
			{
				if(terazStrela->typ==BOMB_BALL)
				{
					odrazBombBall(terazStrela);

					pred=terazStrela;
					terazStrela=terazStrela->next;
					continue;
				}

				if(pred!=NULL)
				{
					pred->next=terazStrela->next;
					del=terazStrela;
					terazStrela=terazStrela->next;
					free(del);
					continue;
				}
				else
				{
					del=zoznamStrel;
					zoznamStrel=zoznamStrel->next;
					free(del);
					terazStrela=terazStrela->next;
					continue;
				}
			}

			pred=terazStrela;
			terazStrela=terazStrela->next;
		}

		terazPrekazka=terazPrekazka->next;
	}

	return 0;
}

void quitPrekazka(prekazka **p)
{
	prekazka *teraz;
	prekazka *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		SDL_FreeSurface(teraz->g);
		teraz=teraz->next;
		free(del);
	}

	//zoznamPrekazok=NULL;
	*p=NULL;
}
