
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "robot.h"

robot *zoznamRobot;

void initRobot()
{
	zoznamRobot=NULL;
}

void pridajRobot(robot **p,int px,int py,int pw,int ph,
		    SDL_Surface *pimg,int pmaxcas,int pactivePolicko,int pmaxpolicko,
		    int pvrstva,int ssmer,int szbran,int spravdepodobnost)
{
	robot *teraz;
	teraz = malloc(sizeof(robot));

	teraz->x=px;
	teraz->y=py;
	teraz->w=pw;
	teraz->h=ph;
	teraz->image=pimg;
	teraz->cas=0;
	teraz->maxCas=pmaxcas;
	teraz->policko=0;
	teraz->activePolicko=pactivePolicko;
	teraz->maxPolicko=pmaxpolicko;
	teraz->vrstva=pvrstva;
	teraz->smer=ssmer;
	teraz->zbran=szbran;
	teraz->pravdepodobnost=spravdepodobnost;

	teraz->next=*p;
	*p=teraz;
}

void kresliRobot(robot **p)
{
	robot *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		pridajImage(&zoznamImage,teraz->image,teraz->x,teraz->y,teraz->w,teraz->h,
		teraz->policko*teraz->w,0,teraz->w,teraz->h,teraz->vrstva,1);

		teraz=teraz->next;
	}
}

int koliziaBulanecRobot(bulanec *p,int px,int py)
{
	robot *teraz;
	int x,y,w,h;

	teraz=zoznamRobot;
		
	getRozmery(p,&x,&y,&w,&h);
	x+=px;
	y+=py;
	
	while(teraz!=NULL)
	{
		if(p->bonus!=BONUS_DUCH &&
		   koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,teraz->w,teraz->h)==1)return 1;

		if(teraz->smer==VPRAVO && teraz->strel==0 &&
		   x>teraz->x && y>teraz->y && y<teraz->y+teraz->h && rand()%teraz->pravdepodobnost==0)
		{
			pridajStrelaAnonymous(&zoznamStrel,teraz->zbran,
			teraz->x+teraz->w/2,teraz->y+teraz->h/2,teraz->smer);

			teraz->policko=teraz->activePolicko;
			teraz->cas=0;
			teraz->strel=50;
		}

		if(teraz->smer==VLAVO && teraz->strel==0 &&
		   x<teraz->x && y>teraz->y && y<teraz->y+teraz->h && rand()%teraz->pravdepodobnost==0)
		{
			pridajStrelaAnonymous(&zoznamStrel,teraz->zbran,
			teraz->x+teraz->w/2,teraz->y+teraz->h/2,teraz->smer);

			teraz->policko=teraz->activePolicko;
			teraz->cas=0;
			teraz->strel=50;
		}

		if(teraz->smer==HORE && teraz->strel==0 &&
		   y<teraz->y && x>teraz->x &&
		   x<teraz->x+teraz->w && rand()%teraz->pravdepodobnost==0)
		{
			pridajStrelaAnonymous(&zoznamStrel,teraz->zbran,
			teraz->x+teraz->w/2,teraz->y+teraz->h/2,teraz->smer);

			teraz->policko=teraz->activePolicko;
			teraz->cas=0;
			teraz->strel=50;
		}

		if(teraz->smer==DOLE && teraz->strel==0 &&
		  y>teraz->y && x>teraz->x && 
		  x<teraz->x+teraz->w && rand()%teraz->pravdepodobnost==0)
		{
			pridajStrelaAnonymous(&zoznamStrel,teraz->zbran,
			teraz->x+teraz->w/2,teraz->y+teraz->h/2,teraz->smer);

			teraz->policko=teraz->activePolicko;
			teraz->cas=0;
			teraz->strel=50;
		}

		teraz=teraz->next;
	}

	return 0;
}

int koliziaStrelaRobot()
{
	robot *terazRobot;
	strela *terazStrela;
	strela *del;
	strela *pred;

	terazRobot=zoznamRobot;
	
	while(terazRobot!=NULL)
	{
		terazStrela=zoznamStrel;
		pred=NULL;

		while(terazStrela!=NULL)
		{
			if(terazStrela->prejde==0 && terazStrela->vidiet==0 &&
			   koliziaObdlznikov(terazRobot->x,terazRobot->y,
			   terazRobot->w,terazRobot->h,
			   terazStrela->x,terazStrela->y,
			   terazStrela->w,terazStrela->h))
			{
				if(terazStrela->typ==BOMB_BALL)
				{
					odrazBombBall(terazStrela);

					pred=terazStrela;
					terazStrela=terazStrela->next;
					continue;
				}

				if(pred!=NULL)
				{
					pred->next=terazStrela->next;
					del=terazStrela;
					terazStrela=terazStrela->next;
					free(del);
					continue;
				}
				else
				{
					del=zoznamStrel;
					zoznamStrel=zoznamStrel->next;
					free(del);
					terazStrela=terazStrela->next;
					continue;
				}
			}

			pred=terazStrela;
			terazStrela=terazStrela->next;
		}

		terazRobot=terazRobot->next;
	}

	return 0;
}

void akciaRobot(robot **p)
{
	robot *teraz;

	teraz=*p;

	while(teraz!=NULL)
	{
		if(teraz->strel>0)teraz->strel--;

		teraz->cas++;

		if(teraz->cas==teraz->maxCas)
		{
			teraz->cas=0;
			teraz->policko++;

			if(teraz->policko==teraz->activePolicko)teraz->policko=0;
			if(teraz->policko==teraz->maxPolicko)teraz->policko=0;
		}

		teraz=teraz->next;
	}
}

void quitRobot(robot **p)
{
	robot *teraz;
	robot *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		SDL_FreeSurface(teraz->image);
		teraz=teraz->next;
		free(del);
	}

	*p=NULL;
}
  
