
#ifndef ROBOT_H

#define ROBOT_H


typedef struct s_robot
{
	int x; //suranica robota X
	int y; //suranica robota Y
	int w; //sirka jedeho policka
	int h; //dlzka jedneho policka
	SDL_Surface *image; //obrazok, ktory sa animuje musi ist ako poicka filmu
	int cas; //citac casu
	int maxCas;//cas, za ktory sa zmeni pociko
	int policko;//policko , ktore je prave zobrazene
	int activePolicko;//policko od ktoreho sa zacina, ked sa animacia activuje
	int maxPolicko;//pocet policiek
	int vrstva; //vrstva na ktorej je robot
	int strel; //moze robot strielat (0-ano)
	int smer; //smer, ktorym robot striela
	int zbran; //zbran, ktorou robot striela
	int pravdepodobnost; // no commnet
	struct s_robot *next;
} robot;

extern robot *zoznamRobot;

extern void initRobot();

/*
 * **p - pointer na zoznam roborov
 * px,py - usradnice robota na ploche
 * pw ph - rozmery robota
 * *pimg - odkaz na surfrace animacie robota
 * pmaxcas - cas, za ktory sa vimenia polika animacie
 * pactivePolicko - policko od ktoreho sa zacne, ked robot vystreli
 * pmaxpolicko - pocet polikok animacie
 * vrstva - vrstav na ktorej sa robot nachadza
 * ssmer - smer korym robot vystreli
 * szbran - zbran ktorov robot vystreli
 * spravdepodobnost - pravdepodobnost s ktorov robot vysreli "1 k spravdepodobnost"
 */
extern void pridajRobot(robot **p,int px,int py,int pw,int ph,
		    SDL_Surface *pimg,int pmaxcas,int pactivePolicko,int pmaxpolicko,
		    int pvrstva,int ssmer,int szbran,int spravdepodobnost);

extern void kresliRobot(robot **p);

/*
 * Zistuje ci je kolzia medzi tuxancom *p a
 * robotmi ulozenymi v pointeri na strukturu zoznamRobot.
 * Ak je a bulanec sa nachadza v smere vystrelu, robot sa pokusi vystrelit
 *
 * parametre:
 * *p - pointer na strukturu tuxanca
 * px py - hodnoty, ktore sa maju pricitat k suradnici tuxanca
 * (pouziva sa iba vo funkcii, suradnice ulozene v strukture sa nezmenia)
 *
 * navratova hodnota:
 * 0 - klzia nenastala
 * 1 - kolizia nastala
 */
extern int koliziaBulanecRobot(bulanec *p,int px,int py);

/*
 * Zistuje ci je kolzia medzi strelami ulozenymi v zoznamStitiel
 * a prekazkami ulozenymi v zozname zoznamRobot.
 * Ak strela narazi na robota, aktivuje odstrani sa zoz zoznamu stiel.
 */
int koliziaStrelaRobot();

extern void akciaRobot(robot **p);

extern void quitRobot(robot **p);

#endif


