
#include "interface.h"
#include "zbrane.h"
#include "bulanec.h"
#include "panel.h"
#include "strela.h"
#include "prekazka.h"
#include "vec.h"
#include "animacia.h"
#include "robot.h"
#include "teleport.h"
#include "trubky.h"
#include "hraSa.h"

#include "siet.h"

#ifdef NET_MULTIPLAYER

#ifndef WIN32

#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#elif

#include <winsock.h>

#endif

static SDL_Thread *thread;
static SDL_mutex *mutex_network;

network_game game;

TCPsocket client_sock;
//int mysocket=-1;
int failed_flag;

#define serversocket mysocket


int processEvent(char *msg) {
	char event[16];
	int bulanec;
	char params[128];
	int i;
	char *tmp;
	int iparams[8];

	sscanf(msg,"%s ",(char *)&event);
	strcpy(params,(char*) ((int)msg+strlen(event)) );
SDL_LockMutex(mutex_display);
	if (strcmp(event,"quit")==0) {
		exit(1);
	} else if (strcmp(event,"setpos")==0) {
		sscanf(params,"%i=%*s",&bulanec);
		lockBulanec(bulanec);
		sscanf(params+1,"%d=%d %d %d", &bulanec, &armadaBulancov[bulanec]->x,&armadaBulancov[bulanec]->y,&armadaBulancov[bulanec]->otoceny);
		unlockBulanec(bulanec);
		kresliBulanec(armadaBulancov[bulanec]);
	} else if (strcmp(event,"bmove")==0) {
		int smer;
//		sscanf(params,"%i=%*s",&bulanec);
		sscanf(params+1,"%d=%d", &bulanec, &smer);
		pohybBulanec(armadaBulancov[bulanec], smer);
		kresliBulanec(armadaBulancov[bulanec]);
	} else if (strcmp(event,"bshoot")==0) {
		sscanf(params,"%i",&bulanec);
		strielbaBulanec(armadaBulancov[bulanec]);
	} else if (strcmp(event,"breset")==0 && stav==CLIENT) {
		sscanf(params,"%i",&bulanec);
		lockBulanec(bulanec);
		for (i = 1; i < POCET_ZBRANI; i++)
			armadaBulancov[bulanec]->naboje[i] = 0;
		armadaBulancov[bulanec]->naboje[0] = MAX_POCET_STRIEL;
		armadaBulancov[bulanec]->zbran=PISTOL;
		armadaBulancov[bulanec]->mozeStrielat=0;
		armadaBulancov[bulanec]->mrtvy=0;
		pridajPrekresli(&zoznamPrekresli,armadaBulancov[bulanec]->x-20,armadaBulancov[bulanec]->y-20,KRIZ_SIZE_X+10,KRIZ_SIZE_Y+10);

		//Bude v rohu a nemel by se kreslit
		armadaBulancov[bulanec]->otoceny=-1;
		armadaBulancov[bulanec]->x = 0;
		armadaBulancov[bulanec]->y = 0;
		unlockBulanec(bulanec);
	} else if ((strcmp(event,"putitem") == 0) && stav == CLIENT) {
/* ZALOHA
		sscanf(params, "%d %d %d %d %d %d %d", &iparams[0], &iparams[1], &iparams[2], &iparams[3], 
			&iparams[4], &iparams[5], &iparams[6]);
		pridajVec(&zoznamVeci, iparams[0], iparams[1], iparams[2], iparams[3], 
			iparams[4], iparams[5], iparams[6]);
*/
		sscanf(params, "%d %d %d", &iparams[0], &iparams[1], &iparams[2]);
		pridajVec(&zoznamVeci, iparams[0], iparams[1], iparams[2]);
	} else if (strcmp(event,"dropitem") == 0) {
	} else if (strcmp(event,"start") == 0 && stav==CLIENT) {
		odstranSpravu();
		setMiesto_v_hre(HRA_SA);
		sendEvent("started",(char *) NULL);
	} else if (strcmp(event,"started") == 0 && stav == SERVER) {
		SDL_LockMutex(game.mutex);
		game.started = 1;
		SDL_UnlockMutex(game.mutex);
	} else if (strcmp(event,"setlevel") == 0 && stav==CLIENT) {
		SDL_LockMutex(game.mutex);
		sscanf(params,"%as",&game.level);
		printf(">> Level set to '%s'\n", game.level);
		tmp = malloc( (strlen(game.level) + strlen(PATH_DATA) + 1) * sizeof(char) );

		strcpy(tmp, PATH_DATA);
		strcat(tmp, game.level);
		SDL_UnlockMutex(game.mutex);
		
		printf(">> Cesta k levelu je: '%s', nacitam...\n", tmp);
		
/**********************************
 *POZOR: funckiu nacitajLevel oprav
 *
 ***********************************
 */
		//nacitajLevel(tmp);

		free(tmp);
		printf(">> Level nacten\n");
	}
SDL_UnlockMutex(mutex_display);
	return 0;
}

void netFailure(void) {
	fprintf(stderr, "Error: %s\n", SDLNet_GetError());
	exit(1);
}

int runServer(void *nic)
{	
	IPaddress ip;	//,*remoteip;
	TCPsocket server;

	Uint16 port;
	//Uint32 ipaddr;
	char sprava[STR_SIZE];


	if (SDLNet_Init()==-1) netFailure();
	port = (Uint16) 2200;

	if (SDLNet_ResolveHost(&ip, NULL, port)) netFailure();

	server = SDLNet_TCP_Open(&ip);
	if (!server) netFailure();
	while(1) {
		client_sock = SDLNet_TCP_Accept(server);
		if(!client_sock) {
			SDL_Delay(100);
		} else break;
	}

	while(1)
	{
		if(SDLNet_TCP_Recv(client_sock,sprava,STR_SIZE)<=0)
		{
			fprintf(stderr,"Connection broken!\n");
			return 1;
		}
#ifdef DEBUG
		printf("Received data: %s", sprava);
#endif
		if (strlen(sprava) <= 0) failed_flag++;
			else failed_flag = 0;
		if (failed_flag>15) exit(1);
		if (processEvent(sprava)<0) break;
	}
	return 0;
}

int runClient(void *nic)
{
	IPaddress ip;
	Uint16 port;
	
	char sprava[STR_SIZE];

	port = (Uint16) 2200;
 	if (SDLNet_ResolveHost(&ip, "127.0.0.1", port)==1) netFailure();

	client_sock = SDLNet_TCP_Open(&ip);

	if (!client_sock) netFailure();

	while(1)
	{
		if(SDLNet_TCP_Recv(client_sock,sprava,STR_SIZE)<0)
		{
			fprintf(stderr,"Connection broken!\n");
			return 1;
		}
#ifdef DEBUG
		printf("Received data: %s", sprava);
#endif
		if (processEvent(sprava)<0) return 0;
	}
}

/*
 *  Send event to the server
 */
void sendEvent(char *event, char *parameters) {
	SDL_LockMutex(mutex_network);
	if (stav==NONE) return;
	int retcode;
	int len = strlen(event) + 1;
	if (parameters!=NULL) len+=strlen(parameters) +2;
	char* buffer = malloc(sizeof(char) * len);
	buffer[0] = '\0';
	strcpy(buffer,event);
	if (parameters!=NULL) {
		strcat(buffer," ");
		strcat(buffer,parameters);
	}
#ifdef DEBUG
	printf("Sending event text: '%s'\n",buffer);
#endif
	strcat(buffer,"\n");
	retcode = SDLNet_TCP_Send(client_sock,buffer,sizeof(char) * len);
	free(buffer);
	if (retcode<((signed int)(sizeof(char) * len))) {
		fprintf(stderr,"Connection to server failed.\n");
		return;	//I will need to rewrite this function to report result
	}	
	else 
	{
		//Wait for response?
	}
	
	SDL_UnlockMutex(mutex_network);
}

void initClientLink() {
	
}

void initServer()
{	
	mutex_network = SDL_CreateMutex();
	thread=SDL_CreateThread(runServer,NULL);

}

void initClient()
{
	mutex_network = SDL_CreateMutex();
	thread=SDL_CreateThread(runClient,NULL);
}

/*
 * Inicializace klientu
 * */

void initNetworkGame(int level) {
	game.mutex = SDL_CreateMutex();
	SDL_LockMutex(game.mutex);

	game.level = malloc(16*sizeof(char));
	sprintf(game.level,"level%i",level);
	game.players = 2;
	game.started = 0;

	sendEvent("setlevel", game.level);
	sendEvent("start", (char *) NULL);
	
	SDL_UnlockMutex(game.mutex);
}


#endif
