
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "animacia.h"
#include "vec.h"
#include "zvuky.h"
#include "strela.h"

//#define PISTOL_EXTRA

strela *zoznamStrel;

static SDL_Surface *g_strela;
static SDL_Surface *g_lasserX;
static SDL_Surface *g_lasserY;
static SDL_Surface *g_bombball;

static bulanec *anonymous;

void initStrela()
{
	g_strela = loadImage(PATH_IMAGE "strela.png",1);
	g_lasserX = loadImage(PATH_IMAGE "lasserX.png",1);
	g_lasserY = loadImage(PATH_IMAGE "lasserY.png",1);
	g_bombball = loadImage(PATH_IMAGE "bomb-ball.png",0);

	anonymous=newBulanec(0,0,0);
	zoznamStrel=NULL;
}

void pridajStrelaAnonymous(strela **p,int typ,int x,int y,int smer)
{
	anonymous->x=x;
	anonymous->y=y;
	anonymous->zbran=typ;
	anonymous->otoceny=smer;
	pridajStrela(p,anonymous,typ);
}

void pridajStrela(strela **p,bulanec *b,int typ)
{
	int pocet;
	int i;
	strela *teraz;

	switch(typ)
	{
		case PISTOL:
			pocet=1;
			prehrajZvuk(ZVUK_VYSTREL1);
		break;
		case PISTOL_DUAL:
			prehrajZvuk(ZVUK_VYSTREL1);
			pocet=2;
			prehrajZvuk(ZVUK_VYSTREL1);
		break;
		case BROKOVNICA:
			pocet=5;
			prehrajZvuk(ZVUK_VYSTREL3);
		break;
		case SAMOPAL:
			pocet=5;
			prehrajZvuk(ZVUK_VYSTREL2);
		break;
		case LASSER:
			pocet=20;
			prehrajZvuk(ZVUK_LASSER);
		break;
		case BOMB_BALL:
			pocet=1;
		break;
		default:
			pocet=-1;
		break;
	}

	for(i=0;i<pocet;i++)
	{
		teraz=malloc(sizeof(strela));
		memset(teraz,0,sizeof(strela));
		
		teraz->smer=b->otoceny;
		teraz->vidiet=0;
		teraz->prejde=(b->bonus==BONUS_DUCH && b->casBonus>0?1:0);
		teraz->autorStreli=b;
		teraz->policko=0;
		teraz->typ=typ;

		if(typ==BOMB_BALL)
			teraz->maxPolicko=BOMB_BALL_ANIMACIA;
		else
			teraz->maxPolicko=STRELA_ANIMACIA;

		if(teraz->typ==LASSER)
		{
			if(teraz->smer==VPRAVO || teraz->smer==VLAVO)
			{
				teraz->w=LASSER_DLZKA;
				teraz->h=LASSER_SIRKA;
			}

			if(teraz->smer==HORE || teraz->smer==DOLE)
			{
				teraz->w=LASSER_SIRKA;
				teraz->h=LASSER_DLZKA;
			}
		}

		if(teraz->typ>=BOMB_BALL)
		{
			teraz->w=BOMB_BALL_SIZE_X;
			teraz->h=BOMB_BALL_SIZE_Y;
		}

		if(teraz->typ>=PISTOL && teraz->typ<=SAMOPAL)
		{
			teraz->w=STRELA_SIZE_X;
			teraz->h=STRELA_SIZE_Y;
		}

		switch(b->otoceny)
		{
			case HORE :
				switch(typ)
				{
					case PISTOL:
					case PISTOL_DUAL:
						if(typ==PISTOL_DUAL)
							teraz->x=b->x+10*(i==0?-1:+1);
						else
							teraz->x=b->x+5+(rand()%5-2);

						teraz->y=b->y-(BULANEC_VYSKA/2+5);
						teraz->py=-RYCHLOST_PISTOL;
					break;
					case SAMOPAL:
						teraz->x=b->x+(rand()%20-10);
						teraz->y=(b->y-(BULANEC_VYSKA/2+5))-(rand()%10+1);
						teraz->px=0;//(rand()%2-1);
						teraz->py=-RYCHLOST_SAMOPAL;
						teraz->vidiet=i;
					break;
					case BROKOVNICA:
						teraz->x=b->x;
						teraz->y=b->y-(BULANEC_VYSKA/2+5);
						teraz->px=i-2;
						teraz->py=-RYCHLOST_BROKOVNICA;
					break;
					case LASSER:
						teraz->x=b->x+5;
						teraz->y=b->y-(BULANEC_VYSKA/2+5);
						teraz->py=-RYCHLOST_LASSER;
						teraz->vidiet=i;
					break;
					case BOMB_BALL:
						teraz->x=b->x+5;
						teraz->y=b->y-(BULANEC_VYSKA/2+5);
						teraz->py=-RYCHLOST_BOMB_BALL;
						teraz->vidiet=0;
					break;
				}
			break;
			case VPRAVO :
				switch(typ)
				{
					case PISTOL:
					case PISTOL_DUAL:
						if(typ==PISTOL_DUAL)
							teraz->y=b->y+10*(i==0?-1:+1);
						else
							teraz->y=b->y-5+(rand()%5-2);

						teraz->x=b->x+(BULANEC_SIRKA/2+5);
						teraz->px=+RYCHLOST_PISTOL;
					break;
					case SAMOPAL:
						teraz->x=(b->x+(BULANEC_SIRKA/2+5))+(rand()%10+1);
						teraz->y=b->y+(rand()%20-10);
						teraz->px=+RYCHLOST_SAMOPAL;
						teraz->py=0;//(rand()%2-1);
						teraz->vidiet=i;
					break;
					case BROKOVNICA:
						teraz->x=b->x+(BULANEC_SIRKA/2+5);
						teraz->y=b->y;
						teraz->py=i-2;
						teraz->px=+RYCHLOST_BROKOVNICA;
					break;
					case LASSER:
						teraz->y=b->y-5;
						teraz->x=b->x+(BULANEC_SIRKA/2+5);
						teraz->px=+RYCHLOST_LASSER;
						teraz->vidiet=i;
					break;
					case BOMB_BALL:
						teraz->y=b->y-5;
						teraz->x=b->x+(BULANEC_SIRKA/2+5);
						teraz->px=+RYCHLOST_BOMB_BALL;
						teraz->vidiet=0;
					break;
				}
			break;
			case VLAVO :
				switch(typ)
				{
					case PISTOL:
					case PISTOL_DUAL:
						if(typ==PISTOL_DUAL)
							teraz->y=b->y+10*(i==0?-1:+1);
						else
							teraz->y=b->y+5+(rand()%5-2);

						teraz->x=b->x-(BULANEC_SIRKA/2+5);
						teraz->px=-RYCHLOST_PISTOL;
					break;
					case SAMOPAL:
						teraz->x=(b->x-(BULANEC_SIRKA/2+5))-(rand()%10+1);
						teraz->y=b->y-(rand()%20-10);
						teraz->px=-RYCHLOST_SAMOPAL;
						teraz->py=0;//(rand()%2-1);
						teraz->vidiet=i;
					break;
					case BROKOVNICA:
						teraz->x=b->x-(BULANEC_SIRKA/2+5);
						teraz->y=b->y;
						teraz->py=i-2;
						teraz->px=-RYCHLOST_BROKOVNICA;
					break;
					case LASSER:
						teraz->y=b->y+5;
						teraz->x=b->x-(BULANEC_SIRKA/2+5);
						teraz->px=-RYCHLOST_LASSER;
						teraz->vidiet=i;
					break;
					case BOMB_BALL:
						teraz->y=b->y+5;
						teraz->x=b->x-(BULANEC_SIRKA/2+5);
						teraz->px=-RYCHLOST_BOMB_BALL;
						teraz->vidiet=0;
					break;
				}
			break;
			case DOLE :
				switch(typ)
				{
					case PISTOL:
					case PISTOL_DUAL:
						if(typ==PISTOL_DUAL)
							teraz->x=b->x+10*(i==0?-1:+1);
						else
							teraz->x=b->x+5+(rand()%5-2);

						teraz->y=b->y+(BULANEC_VYSKA/2+5);
						teraz->py=+RYCHLOST_PISTOL;
					break;
					case SAMOPAL:
						teraz->x=b->x+(rand()%20-10);
						teraz->y=(b->y+(BULANEC_VYSKA/2+5))+(rand()%10+1);
						teraz->px=0;//(rand()%2-1);
						teraz->py=+RYCHLOST_SAMOPAL;
						teraz->vidiet=i;
					break;
					case BROKOVNICA:
						teraz->x=b->x;
						teraz->y=b->y+(BULANEC_VYSKA/2+5);
						teraz->px=i-2;
						teraz->py=+RYCHLOST_BROKOVNICA;
					break;
					case LASSER:
						teraz->y=b->y+(BULANEC_VYSKA/2+5);
						teraz->x=b->x+5;
						teraz->py=+RYCHLOST_LASSER;
						teraz->vidiet=i;
					break;
					case BOMB_BALL:
						teraz->x=b->x+5;
						teraz->y=b->y+(BULANEC_VYSKA/2+5);
						teraz->py=RYCHLOST_BOMB_BALL;
						teraz->vidiet=0;
					break;
				}
			break;
		}
		
		teraz->typ=typ;
		teraz->next=*p;
		*p=teraz;
	}
}

void kresliStrela(strela **p)
{
	strela *teraz;

	teraz=*p;

	while(teraz!=NULL)
	{
		if(teraz->vidiet==0)
		{
			if(teraz->typ==LASSER)
			{
				pridajImage(&zoznamImage,
				(teraz->smer==VPRAVO || teraz->smer==VLAVO?g_lasserX:g_lasserY)
				,teraz->x,teraz->y,teraz->w,teraz->h,0,0,teraz->w,teraz->h,1,1);
			}

			if(teraz->typ==BOMB_BALL)
			{
				pridajImage(&zoznamImage,g_bombball,teraz->x,teraz->y,
				teraz->w,teraz->h,teraz->w*teraz->policko,0,teraz->w,teraz->h,1,1);
			}

			if(teraz->typ>=PISTOL && teraz->typ<=SAMOPAL)
			{
				pridajImage(&zoznamImage,g_strela,teraz->x,teraz->y,
				teraz->w,teraz->h,0,0,teraz->w,teraz->h,1,1);
			}
		}

		teraz=teraz->next;
	}
}

int nahodnySmer(int n)
{
	int ret;

	do{
		ret=rand()%3-1;
	}while(ret==n);

	return ret;
}

void odrazBombBall(strela *p)
{
	if(p->smer==HORE)
	{
		p->px=nahodnySmer(p->px)*RYCHLOST_BOMB_BALL;
		p->py=+RYCHLOST_BOMB_BALL;
		p->smer=DOLE;
		p->x+=p->px;
		p->y+=p->py;
		p->autorStreli=NULL;
		prehrajZvuk(ZVUK_ODRAZ_R);
		return;
	}

	if(p->smer==VPRAVO)
	{
		p->py=nahodnySmer(p->py)*RYCHLOST_BOMB_BALL;
		p->px=-RYCHLOST_BOMB_BALL;
		p->smer=VLAVO;
		p->x+=p->px;
		p->y+=p->py;
		p->autorStreli=NULL;
		prehrajZvuk(ZVUK_ODRAZ_R);
		return;
	}

	if(p->smer==VLAVO)
	{
		p->py=nahodnySmer(p->py)*RYCHLOST_BOMB_BALL;
		p->px=+RYCHLOST_BOMB_BALL;
		p->smer=VPRAVO;
		p->x+=p->px;
		p->y+=p->py;
		p->autorStreli=NULL;
		prehrajZvuk(ZVUK_ODRAZ_L);
		return;
	}

	if(p->smer==DOLE)
	{
		p->px=nahodnySmer(p->px)*RYCHLOST_BOMB_BALL;
		p->py=-RYCHLOST_BOMB_BALL;
		p->smer=HORE;
		p->x+=p->px;
		p->y+=p->py;
		p->autorStreli=NULL;
		prehrajZvuk(ZVUK_ODRAZ_L);
		return;
	}
}

int presunStrelu(strela *strela,int s_in,int s_out,int x,int y,int w,int h)
{
	int px=0,py=0;
	int rychlost=0;

	setSmer(s_in,&px,&py);
	px*=-1; py*=-1;

	//printf("%d %d\n",terazStrela->smer,terazTrubka->smer);
	if(strela->smer==negujSmer(s_in))
	{
		
		setSmer(s_out,&px,&py);

		if(abs(strela->px)>5)rychlost=abs(strela->px);
		if(abs(strela->py)>5)rychlost=abs(strela->py);
	
		strela->px=px*rychlost;
		strela->py=py*rychlost;
		strela->vidiet=40;
		strela->autorStreli=NULL;

		switch(s_out)
		{
			case HORE:
				if(strela->smer==VPRAVO || strela->smer==VLAVO)prehod(&strela->w,&strela->h);
				strela->x=x+rand()%w;
				strela->y=y-(5+strela->h);
				strela->smer=HORE;
			break;
			case VPRAVO:
				if(strela->smer==HORE || strela->smer==DOLE)prehod(&strela->w,&strela->h);
				strela->x=x+w+5;
				strela->y=y+rand()%h/2;
				strela->smer=VPRAVO;
			break;
			case VLAVO:
				if(strela->smer==HORE || strela->smer==DOLE)prehod(&strela->w,&strela->h);
				strela->x=x-(strela->w+5);
				strela->y=y+rand()%h;
				strela->smer=VLAVO;
			break;
			case DOLE:
				if(strela->smer==VPRAVO || strela->smer==VLAVO)prehod(&strela->w,&strela->h);
				strela->x=x+rand()%w;
				strela->y=y+h+5;
				strela->smer=DOLE;
			break;
		}

		return 1;
	}

	return 0;
}

int koliziaStrelaBombBall()
{
	strela *terazStrela1;
	strela *terazStrela2;
	strela *del;
	strela *pred;

	terazStrela1=zoznamStrel;
	
	while(terazStrela1!=NULL)
	{
		terazStrela2=zoznamStrel;

		while(terazStrela2!=NULL)
		{
			if(terazStrela1->typ==BOMB_BALL && terazStrela2->typ!=BOMB_BALL &&
			   koliziaObdlznikov(terazStrela1->x,terazStrela1->y,
			   terazStrela1->w,terazStrela1->h,
			   terazStrela2->x,terazStrela2->y,
			   terazStrela2->w,terazStrela2->h))
			{
				if(terazStrela2->typ!=LASSER)
				{
					terazStrela2->typ=ZBRAN_ZIADNA;
					odrazBombBall(terazStrela1);
					prehrajZvuk(ZVUK_ODRAZ_ZBRAN);
				}
				else
				{
					terazStrela1->typ=ZBRAN_ZIADNA;
					pridajAnimacia(&zoznamAnimacia,terazStrela1->x-10,terazStrela1->y-10,
					VYBUCH_SIZE_X,VYBUCH_SIZE_Y,
					loadImage(PATH_IMAGE "vybuch.png",1),3,0,10,1,0,0,1);
				}
			}

			terazStrela2=terazStrela2->next;
		}

		terazStrela1=terazStrela1->next;
	}

	terazStrela1=zoznamStrel;
	pred=NULL;

	while(terazStrela1!=NULL)
	{
		if(terazStrela1->typ==ZBRAN_ZIADNA)
		{
			if(pred!=NULL)
			{
				pred->next=terazStrela1->next;
				del=terazStrela1;
				terazStrela1=terazStrela1->next;
				free(del);
				continue;
			}
			else
			{
				del=zoznamStrel;
				zoznamStrel=zoznamStrel->next;
				free(del);
				terazStrela1=terazStrela1->next;
				continue;
			}
		}

		pred=terazStrela1;
		terazStrela1=terazStrela1->next;
	}

	return 0;
}

void akciaStrela(strela **p)
{
	strela *teraz;
	strela *pred;
	strela *del;

	teraz=*p;
	pred=NULL;
	
	//kresliStrela(p);
	
	while(teraz!=NULL)
	{
		if(teraz->vidiet!=0)
		{
			teraz->vidiet--;
			pred=teraz;
			teraz=teraz->next;
			continue;
		}

		teraz->policko++;
		if(teraz->policko==teraz->maxPolicko)teraz->policko=0;

		pridajPrekresli(&zoznamPrekresli,teraz->x-10,teraz->y-10,
		teraz->w+20,teraz->h+20);
		
		teraz->x+=teraz->px;
		teraz->y+=teraz->py;

		if((teraz->x)>=HRACIA_PLOCHA_SIZE_X || (teraz->x)<0 ||
		   (teraz->y)>=HRACIA_PLOCHA_SIZE_Y || (teraz->y)<0)
		{
			if(pred!=NULL)
			{
				pred->next=teraz->next;
				del=teraz;
				teraz=teraz->next;
				free(del);
				continue;
			}
			else
			{
				del=*p;
				*p=(*p)->next;
				free(del);
				teraz=teraz->next;
				continue;
			}
		}

		pred=teraz;
		teraz=teraz->next;
	}
}

void quitStrela(strela **p)
{
	strela *teraz;
	strela *del;

	destroyBulanec(anonymous);

	SDL_FreeSurface(g_strela);
	SDL_FreeSurface(g_lasserX);
	SDL_FreeSurface(g_lasserY);
	SDL_FreeSurface(g_bombball);

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		teraz=teraz->next;
		free(del);
	}

	*p=NULL;
}
