#ifndef STRELA_H

#define STRELA_H

#include "zbrane.h"

#define STRELA_SIZE_X 5
#define STRELA_SIZE_Y 5

#define LASSER_DLZKA 20
#define LASSER_SIRKA 5

#define BOMB_BALL_SIZE_X 20
#define BOMB_BALL_SIZE_Y 20

#define STRELA_ANIMACIA 1
#define BOMB_BALL_ANIMACIA 3

typedef struct str_strela
{
	int x; //x-ova suranica na ploche
	int y; //y-ova suranica na ploche
	int w;
	int h;
	int typ; //typ streli
	int px; //smer streli
	int py; //smer streli
	int vidiet; //vidiet strelu ?
	int prejde; //prejde kazdou prekazkou ?
	int smer; //smer streli
	int preletela;
	int policko;
	int maxPolicko;
	bulanec *autorStreli;
	struct str_strela *next;
} strela;

extern strela *zoznamStrel;

extern void initStrela();

/*
 * vystreli davku striel do zoznamu striel **p podla typu t
 * suradnice a smer striel sa urcuje podla polohy tuxanca *b
 */
extern void pridajStrela(strela **p,bulanec *b,int t);

/*
 * To iste, len sa suradnice a smer streli nezistia podla tuxanca
 * ale podla suradnic x,y
 */
extern void pridajStrelaAnonymous(strela **p,int typ,int x,int y,int smer);

extern void kresliStrela(strela **p);

/*
 * funckcia vracia nahodny smer, jeden z { -1 ; 0 ; +1 } - {n}
 */
extern int nahodnySmer(int n);

/*
 * zmeni smer, stereli *p -- platiiba pre strelu bomb-ball
 */
extern void odrazBombBall(strela *p);

/*
 * Presunie strelu na dane miesto
 * *strela - dana strela
 * s_in - smer, ktorym ma strela letiet, aby sa presunula
 * s_out - smer, ktorym strela bude letiet po presune
 * x,y w,h - suradnice a rozmery miesta, do ktoreho ked strela narazi tak sa presunie
 *
 * PS: presunuta strela ma autora NULL
 */
extern int presunStrelu(strela *strela,int s_in,int s_out,int x,int y,int w,int h);

/*
 * zistuje, ci je kolizia medzi strelami a bomb-ballom.
 * ak je klizia bomb-ball - strela - strela zanikne a bomb-ball sa odrazi
 * ak je klizia bomb-ball - lasser - bomb-ball sa znici a vybuchne
 */
extern int koliziaStrelaBombBall();

/*
 * Streli zo zonamu **p, pohne danym smerom,
 * ak streli odlis z areny budu odstranene zo zonamu
 */
extern void akciaStrela(strela **p);

extern void quitStrela(strela **p);

#endif
