

#include "interface.h"
#include "jazyk.h"
#include "suborLevel.h"

char *** zdrojakyLevelov;
static int pocetLevelov;

void initSuborLevelov()
{
	DIR *adresar;
	struct dirent *subor;
	char str[STR_SIZE];
	int i;

	adresar=opendir(PATH_DATA);

	pocetLevelov=0;

	while((subor=readdir(adresar))!=NULL)
	{
		if(strstr(subor->d_name,NAZOV_SUBORU)!=NULL)pocetLevelov++;
	}

	closedir(adresar);

	zdrojakyLevelov = malloc(sizeof(char **)*(pocetLevelov+1));
	memset(zdrojakyLevelov,sizeof(char **)*(pocetLevelov+1),0);

	for(i=0;i<pocetLevelov;i++)
	{
		sprintf(str,PATH_DATA NAZOV_SUBORU "%d",i+1);
		zdrojakyLevelov[i]=loadSuborLevel(str);
		
		if(zdrojakyLevelov[i]!=NULL)
			printf("level %d nacitany\n",i+1);
		else
			fprintf(stderr,"level %d sa nepodarilo nacitat!\n",i+1);
	}
}

int getPocetLevelov()
{
	return pocetLevelov;
}

char ** loadSuborLevel(char *s)
{
	FILE *file;
	int i,j;
	int velkost=0;
	int pocet=0;
	int sirka;
	
	char *p;
	char **riadky;
	char *tu;

#ifdef WIN32
	velkost = p_GetFileSize(s);
#else
	struct stat buf;

	if(lstat(s,&buf)<0)
	{
		fprintf(stderr,"CHYBA: nemozem ziskat status suboru %s!\n",s);
		return NULL;
	}

	velkost=buf.st_size;
#endif

	if((file = fopen(s,"rt"))==NULL)
	{
		fprintf(stderr,"CHYBA: nemozem otvorit subor %s pre citanie\n",s);
		return NULL;
	}

	p = malloc(velkost*sizeof(char));

	if((i=fread(p,velkost*sizeof(char),1,file))!=1)
	{
		fprintf(stderr,"CHYBA: nemozem nacitat udahe zo suboru %s\n",s);
		fclose(file);
		return NULL;
	}

	fclose(file);
	
	for(i=0;i<velkost;i++)
		if(p[i]==ZNAK_KONIEC_RIADKA)pocet++;
	
	riadky = malloc(sizeof(char *) * (pocet+1));
	riadky[pocet]=NULL;
	
	j=0;
	sirka=0;
	tu=NULL;

	for(i=0;i<velkost;i++)
	{
		if(sirka==0)tu = p+i*sizeof(char);
		
		sirka++;
		
		if(p[i]==ZNAK_KONIEC_RIADKA)
		{
			riadky[j] = malloc(sizeof(char *) * sirka+1);
			strncpy(riadky[j],tu,sirka-1);
			riadky[j][sirka-1]=0;
			sirka=0;
			j++;
		}
	}
	
	free(p);

	return riadky;
}

char *getNazovLevelu(int n)
{
	int i;
	char prikaz[STR_SIZE];

	strcpy(prikaz,PRIKAZ_TITLE " ");
	strcat(prikaz,getJazykStr());

	for(i=0;zdrojakyLevelov[n][i]!=NULL;i++)
	{
		if(strncmp(zdrojakyLevelov[n][i],prikaz,strlen(prikaz))==0)
		{
			return zdrojakyLevelov[n][i]+strlen(prikaz);
		}
	}

	return NAZNAMI_NAZOV_LEVELU;
}

void quitSuborLevel()
{
	int i,j;

	for(i=0;i<pocetLevelov;i++)
	{
		j=0;

		for(j=0;zdrojakyLevelov[i][j]!=NULL;j++)
			free(zdrojakyLevelov[i][j]);
	
		free(zdrojakyLevelov[i]);
	}
	
	free(zdrojakyLevelov);
}
