
#include "interface.h"
#include "kurzor.h"
#include "widget_button.h"
#include "tabulka.h"

tabulka zoznamTabulka[TABULKA_POCET+1];
static SDL_Color farba_pisma = {255,255,255,0};// Barva textu
static SDL_Color farba_pisma_cervena = {255,0,0,0};// Barva textu
static char cesta[STR_SIZE];

static SDL_Surface *g_tapeta;
static wid_button *cudlikOk;
static int zvyraznenyRiadok;

void nacitajTabulku()
{
	FILE *file;
	int i;

	if((file = fopen(cesta,"rt"))==NULL)
	{
		fprintf(stderr,"subor %s sa neda otvorit!\n",cesta);
		return;
	}
	
	for(i=0;i<10;i++)
		fscanf(file,"%s %d",zoznamTabulka[i].meno,&zoznamTabulka[i].hodnota);

	fclose(file);
}

void initTabulka()
{
	int i;
	char home[STR_SIZE];

	g_tapeta = loadImage(PATH_IMAGE "main_menu.png",0);
	cudlikOk = newButton(WINDOW_SIZE_X/2-BUTTON_SIZE_X/2,WINDOW_SIZE_Y-75,"Ok");

#ifdef WIN32
	sprintf(home, "%s/%s", getenv("USERPROFILE"), "Tuxanci");
#else
	sprintf(home, "%s/%s", getenv("HOME"), ".tuxanci");
#endif

	sprintf(cesta,"%s/hiscore",home);

	if(access(cesta,F_OK)!=0)
	{
		printf("Vytvaram tabulku %s\n",cesta);

		for(i=0;i<10;i++)
		{
			strcpy(zoznamTabulka[i].meno,"player");
			zoznamTabulka[i].hodnota=0;
		}
		
		ulozTabulku();
	}

	zvyraznenyRiadok=-1;
	nacitajTabulku();
}

int vlozDoTabulky(char *meno,int hodnota)
{
	int i;
	int ret=0;

	strcpy(zoznamTabulka[TABULKA_POCET].meno,meno);
	zoznamTabulka[TABULKA_POCET].hodnota=hodnota;

	for(i=TABULKA_POCET;i>=1;i--)
	{
		if(zoznamTabulka[i].hodnota>zoznamTabulka[i-1].hodnota)
		{
			char menoz[STR_SIZE];
			int hodnotaz;

			strcpy(menoz,zoznamTabulka[i].meno);
			hodnotaz=zoznamTabulka[i].hodnota;

			strcpy(zoznamTabulka[i].meno,zoznamTabulka[i-1].meno);
			zoznamTabulka[i].hodnota=zoznamTabulka[i-1].hodnota;

			strcpy(zoznamTabulka[i-1].meno,menoz);
			zoznamTabulka[i-1].hodnota=hodnotaz;

			zvyraznenyRiadok=i-1;
			ret=1;
		}
	}

	return ret;
}

void vypisTabulku()
{
	int i;

	for(i=0;i<10;i++)
	{
		printf("%2d) %20s %3d\n",i+1,zoznamTabulka[i].meno,zoznamTabulka[i].hodnota);
	}
}

void ulozTabulku()
{
	FILE *file;
	int i;

	if((file = fopen(cesta,"wt"))==NULL)
	{
		fprintf(stderr,"subor %s sa neda otvorit pre zapis!\n",cesta);
		return;
	}
	
	for(i=0;i<10;i++)
		fprintf(file,"%s %d\n",zoznamTabulka[i].meno,zoznamTabulka[i].hodnota);

	fclose(file);
}

void kresliTabulka()
{
	SDL_Rect dst_rect;
	SDL_Surface *text;
	char line[STR_SIZE];
	int width;
	int i;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(g_tapeta,NULL,screen, &dst_rect);
	
	for(i=0;i<10;i++)
	{
		sprintf(line,"%2d) %10s %3d",i+1,zoznamTabulka[i].meno,zoznamTabulka[i].hodnota);
	
		//strcpy(line,"pokus");
		TTF_SizeText(g_font,line,&width,NULL);

		text = TTF_RenderUTF8_Blended(g_font,line,
		(zvyraznenyRiadok==i?farba_pisma_cervena:farba_pisma));

		dst_rect.x=WINDOW_SIZE_X/2-width/2;
		dst_rect.y=150+20*i;
		SDL_BlitSurface(text,NULL,screen,&dst_rect);
		SDL_FreeSurface(text);
	}

	kresliButton(cudlikOk);
	kresliKurzor();

	pridajPrekresli(&zoznamPrekresli,0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);
}

void akciaTabulka()
{
	akciaButton();

	if(isKlik(cudlikOk)==1)setMiesto_v_hre(MAIN_MENU);
}

void quitTabulka()
{
	SDL_FreeSurface(g_tapeta);
	destroyButton(cudlikOk);
}
