
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "zvuky.h"
#include "teleport.h"
 
teleport *zoznamTeleport;

//static SDL_Surface *g_strela;

void initTeleport()
{
	zoznamTeleport=NULL;
}

void pridajTeleport(teleport **p,int x,int y,int w,int h,char *s)
{
	teleport *teraz;

	teraz=malloc(sizeof(teleport));
	teraz->x=x;
	teraz->y=y;
	teraz->w=w;
	teraz->h=h;
	teraz->g=loadImage(s,1);
	teraz->next=*p;
	*p=teraz;
}

teleport *vyberTeleport()
{
	teleport *terazTeleport;
	int i=0;
	int n;

	terazTeleport=zoznamTeleport;

	while(terazTeleport!=NULL)
	{
		i++;
		terazTeleport=terazTeleport->next;
	}

	n=rand()%i;
	i=0;

	terazTeleport=zoznamTeleport;

	while(terazTeleport!=NULL)
	{	
		if(i==n)return terazTeleport;
		terazTeleport=terazTeleport->next;
		i++;
	}

	return NULL;
}

int koliziaBulanecTeleport(bulanec *p,int px,int py)
{
	teleport *teraz;
	teleport *my;
	int x,y,w,h;
	int nx=0,ny=0,ox=0,oy=0;

	teraz=zoznamTeleport;
		
	getRozmery(p,&x,&y,&w,&h);
	x+=px;
	y+=py;
	
	while(teraz!=NULL)
	{
		if(koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,teraz->w,teraz->h))
		{
/*
			if(teraz->next!=NULL)//chod do pri dalsi teleport
				my=teraz->next;
			else //ak dasli nie je chod na prvy
				my=zoznamTeleport;
*/
			do{
				my=vyberTeleport();
			}while(my==teraz);

			switch(p->otoceny)
			{
				case HORE:
					nx=my->x+my->w/2;
					ny=my->y-BULANEC_VYSKA/2;
				break;
				case VPRAVO:
					nx=my->x+(my->w+BULANEC_SIRKA/2);
					ny=my->y+my->h/2;
				break;
				case VLAVO:
					nx=my->x-BULANEC_SIRKA/2;
					ny=my->y+my->h/2;
				break;
				case DOLE:
					nx=my->x+my->w/2;
					ny=my->y+(my->h+BULANEC_VYSKA/2);
				break;
			}

			//zalohus stare suradnice
			ox=p->x;
			oy=p->y;

			//prepis novymi
			p->x=nx;
			p->y=ny;

			//ak su kolizie daj to naspet
			if(koliziaBulancov(p,0,0)!=0)
			{
				p->x=ox;
				p->y=oy;
			}
			else
			{
				p->vidiet=10;
				prehrajZvuk(ZVUK_TELEPORT);
			}

			pridajPrekresli(&zoznamPrekresli,
			x-GRAFIKA_BULANEC_SIRKA,y-GRAFIKA_BULANEC_VYSKA,
			w+GRAFIKA_BULANEC_SIRKA*2,h+GRAFIKA_BULANEC_VYSKA*2);

			return 1;
		}

		teraz=teraz->next;
	}

	return 0;
}

int koliziaStrelaTeleport()
{
	teleport *terazTeleport;
	teleport *my;
	strela *terazStrela;

	terazTeleport=zoznamTeleport;
	
	while(terazTeleport!=NULL)
	{
		terazStrela=zoznamStrel;

		while(terazStrela!=NULL)
		{
			if(koliziaObdlznikov(terazTeleport->x,terazTeleport->y,
			   terazTeleport->w,terazTeleport->h,
			   terazStrela->x,terazStrela->y,
			   terazStrela->w,terazStrela->h))
			{
				int smer=0;

				do{
					my=vyberTeleport();
				}while(my==terazTeleport);

				switch(rand()%4+1)
				{
					case 1 : smer=HORE; break;
					case 2 : smer=VPRAVO; break;
					case 3 : smer=VLAVO; break;
					case 4 : smer=DOLE; break;
				}

				presunStrelu(terazStrela,negujSmer(terazStrela->smer),
				smer,my->x,my->y,my->w,my->h);
			}

			terazStrela=terazStrela->next;
		}

		terazTeleport=terazTeleport->next;
	}

	return 0;
}

void kresliTeleport(teleport **p)
{
	//SDL_Rect dst_rect;
	teleport *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		//dst_rect.x = teraz->x;
		//dst_rect.y = teraz->y;
		
		pridajImage(&zoznamImage,teraz->g,teraz->x,teraz->y,
		teraz->w,teraz->h,0,0,teraz->w,teraz->h,0,1);
		//SDL_BlitSurface(teraz->g,NULL,screen,&dst_rect);

		teraz=teraz->next;
	}
}

void quitTeleport(teleport **p)
{
	teleport *teraz;
	teleport *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		SDL_FreeSurface(teraz->g);
		teraz=teraz->next;
		free(del);
	}

	//zoznamPrekazok=NULL;
	*p=NULL;
}
