
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "trubky.h"
 
trubka *zoznamTrubka;

//static SDL_Surface *g_strela;

void initTrubka()
{
	zoznamTrubka=NULL;
}

void pridajTrubka(trubka **p,int x,int y,int w,int h,int smer,int sid,int sidOut,char *s)
{
	trubka *teraz;

	teraz=malloc(sizeof(trubka));
	teraz->x=x;
	teraz->y=y;
	teraz->w=w;
	teraz->h=h;
	teraz->smer=smer;
	teraz->g=loadImage(s,1);
	teraz->id=sid;
	teraz->idOut=sidOut;
	teraz->next=*p;
	*p=teraz;
}

void kresliTrubka(trubka **p)
{
	//SDL_Rect dst_rect;
	trubka *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		//dst_rect.x = teraz->img_x;
		//dst_rect.y = teraz->img_y;
		
		pridajImage(&zoznamImage,teraz->g,teraz->x,teraz->y,
		teraz->w,teraz->h,0,0,teraz->w,teraz->h,1,0);
		//SDL_BlitSurface(teraz->g,NULL,screen,&dst_rect);

		teraz=teraz->next;
	}
}

trubka *vyberTrubku(int n)
{
	trubka *terazTrubka;

	terazTrubka=zoznamTrubka;

	while(terazTrubka!=NULL)
	{	
		if(terazTrubka->id==n)return terazTrubka;
		terazTrubka=terazTrubka->next;
	}

	return NULL;
}

int koliziaBulanecTrubka(bulanec *p,int px,int py)
{
	trubka *teraz;
	int x,y,w,h;

	teraz=zoznamTrubka;
		
	getRozmery(p,&x,&y,&w,&h);
	x+=px;
	y+=py;
	
	while(teraz!=NULL)
	{

		if(p->bonus!=BONUS_DUCH && teraz->x!=SURADNICA_ZIADNA && koliziaObdlznikov(x,y,w,h,
		   teraz->x,teraz->y,teraz->w,teraz->h)==1)return 1;

		teraz=teraz->next;
	}

	return 0;
}

int koliziaStrelaTrubka()
{
	trubka *terazTrubka;
	trubka *my=NULL;
	strela *terazStrela;
	strela *pred;
	strela *del;
	int cisloTrubky=0;

	terazTrubka=zoznamTrubka;

	while(terazTrubka!=NULL)
	{
		terazStrela=zoznamStrel;
		pred=NULL;

		while(terazStrela!=NULL)
		{
			if(terazStrela->prejde==0 && koliziaObdlznikov(terazTrubka->x,terazTrubka->y,
			   terazTrubka->w,terazTrubka->h,
			   terazStrela->x,terazStrela->y,
			   terazStrela->w,terazStrela->h))
			{
				my=vyberTrubku(terazTrubka->idOut);

				if(!presunStrelu(terazStrela,terazTrubka->smer,my->smer,
				   my->x,my->y,my->w,my->h))
				{
					if(terazStrela->typ==BOMB_BALL)
					{
						odrazBombBall(terazStrela);
	
						pred=terazStrela;
						terazStrela=terazStrela->next;
						continue;
					}

					if(pred!=NULL)
					{
						pred->next=terazStrela->next;
						del=terazStrela;
						terazStrela=terazStrela->next;
						free(del);
						continue;
					}
					else
					{
						del=zoznamStrel;
						zoznamStrel=zoznamStrel->next;
						free(del);
						terazStrela=terazStrela->next;
						continue;
					}
				}
			}

			pred=terazStrela;
			terazStrela=terazStrela->next;
		}

		cisloTrubky++;
		terazTrubka=terazTrubka->next;
	}

	return 0;
}

void quitTrubka(trubka **p)
{
	trubka *teraz;
	trubka *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		SDL_FreeSurface(teraz->g);
		teraz=teraz->next;
		free(del);
	}

	//zoznamPrekazok=NULL;
	*p=NULL;
}
