
#ifndef TRUBKY_H

#define TRUBKY_H

typedef struct str_trubka
{
	int x; //suranica na x-ovej osi
	int y; //suranica na y-ovej osi
	int w; //sirka
	int h; //vyska
	int smer; //smer
	int id;
	int idOut;
	SDL_Surface *g; //obrazok, ktory sa ma zobrazit
	struct str_trubka *next;
} trubka;

extern trubka *zoznamTrubka;

extern void initTrubka();

/*
 * Prida trubku do zoznamu trubiek.
 * **p - pointer ma zoznam trubiek
 * x,y - suranice novej trubky
 * w,h - rozmery novej trubky
 * smer -- smer v ktorm je trubka otvorena
 * sid - identifikacne cislo trubky
 * sodOut -- identifikacne cislo trubky, z ktorej strela vileti,
 *           ked sa streli do trubky, ktora sa teraz vytvori
 */
extern void pridajTrubka(trubka **p,int x,int y,int w,int h,int smer,int sid,int sidOut,char *s);

extern void kresliTrubka(trubka **p);

/*
 * Vrati pointer na trubku s idetifikacnym cislom n
 */
extern trubka *vyberTrubku(int n);

/*
 * Zistuje ci je kolzia medzi tuxancom *p a
 * trubkou ulozenej v pointeri na strukturu zoznamTrubka.
 *
 * parametre:
 * *p - pointer na strukturu tuxanca
 * px py - hodnoty, ktore sa maju pricitat k suradnici tuxanca
 * (pouziva sa iba vo funkcii, suradnice ulozene v strukture sa nezmenia)
 *
 * navratova hodnota:
 * 0 - klzia nenastala
 * 1 - kolizia nastala
 */
extern int koliziaBulanecTrubka(bulanec *p,int px,int py);

/*
 * Zistuje ci je kolzia medzi strelami ulozenymi v zoznamStitiel
 * a prekazkami ulozenymi v zozname zoznaStriel.
 * Ak strela narazi na trubku, nastavi sa jeje hodnota videt
 * na 40. a jej suradnice a  smer sa nastvi tak aby mohla vyletet
 * z dalsej trubky.
 */
extern int koliziaStrelaTrubka();

extern void quitTrubka(trubka **p);

#endif
