
#include "interface.h"
#include "bulanec.h"
#include "hraSa.h"
#include "strela.h"
#include "vec.h"
#include "animacia.h"
#include "zvuky.h"

#ifdef NET_MULTIPLAYER
#include "siet.h"
#endif

vec *zoznamVeci;

void initVec()
{
	zoznamVeci=NULL;
}

void pridajVec(vec **p,int x,int y,int co)
{
	vec *teraz;

	teraz=malloc(sizeof(vec));
	teraz->x=x;
	teraz->y=y;
	teraz->co=co;
	teraz->g=veciSurface[co];
	teraz->policko=0;
	teraz->next=*p;

	if(co>=PISTOL && co<=BOMBA)
	{
		teraz->w=VEC_ZBRAN_SIZE_X;
		teraz->h=VEC_ZBRAN_SIZE_Y;
		teraz->maxPolicko=VEC_MAX_ANIMACIA;
		teraz->cas=500;
	}

	if(co==MINA)
	{
		teraz->w=MINA_SIZE_X;
		teraz->h=MINA_SIZE_Y;
		teraz->maxPolicko=1;
		teraz->cas=-1;
	}

	if(co>=BONUS_RYCHLOST && co<=BONUS_DUCH)
	{
		teraz->w=BONUS_SIZE_X;
		teraz->h=BONUS_SIZE_Y;
		teraz->maxPolicko=BONUS_MAX_ANIMACIA;
		teraz->cas=500;
	}

	*p=teraz;

#ifdef NET_MULTIPLAYER	
	if (stav == SERVER) {
		printf("Posilam predmet...");
		//Odeslu zpravu druhe strane, ze jsem pridal predmet
		char msg[STR_SIZE];
		sprintf(msg, "%d %d %d", x, y, co);
		sendEvent("putitem", msg);
	}
#endif
}

void zobrazZbran(vec **p,bulanec *b)
{
	int x,y,w,h;
	
	vec *teraz;
	vec *pred;
	vec *del;
	int pridaj=0;

	if(b->mrtvy!=0)return;

	teraz=*p;
	pred=NULL;

	while(teraz!=NULL)
	{
		getRozmery(b,&x,&y,&w,&h);

		if(koliziaObdlznikov(x,y,w,h,teraz->x,teraz->y,teraz->w,teraz->h)==1)
		{
			if(teraz->co>=PISTOL && teraz->co<=BOMBA)
			{
				b->zbran=teraz->co;
				
				if(teraz->co==BOMBA) b->naboje[b->zbran]+=3;
				else b->naboje[b->zbran]+=MAX_POCET_STRIEL;
				
				b->mozeStrielat=0;
				b->nabijaSaZasobnik=0;

				prehrajZvuk(ZVUK_ZBRAN);
			}

			if(teraz->co==MINA && b->mrtvy==0)
			{
    				if(b==armadaBulancov[ACTIVE_BULANEC1])
				{
					armadaBulancov[ACTIVE_BULANEC2]->score++;
				}

    				if(b==armadaBulancov[ACTIVE_BULANEC2])
				{
					armadaBulancov[ACTIVE_BULANEC1]->score++;
				}

				pridajPrekresli(&zoznamPrekresli,x,y,w,h);
				kresliBulanec(b);
				pridajAnimacia(&zoznamAnimacia,teraz->x-10,teraz->y-10,
				VYBUCH_SIZE_X,VYBUCH_SIZE_Y,
				loadImage(PATH_IMAGE "vybuch.png",1),3,0,10,1,0,0,1);

				b->mrtvy=1;
				//pridajZbran();
				prehrajZvuk(ZVUK_MINA);
				pridaj=1;
			}

			if(teraz->co>=BONUS_RYCHLOST && teraz->co<=BONUS_DUCH)
			{
				b->bonus=teraz->co;
				b->casBonus=500;
				prehrajZvuk(ZVUK_BONUS);
			}

			pridajPrekresli(&zoznamPrekresli,teraz->x-10,
			teraz->y-10,teraz->w+10,teraz->h+10);

			if(pred!=NULL)
			{
				pred->next=teraz->next;
				del=teraz;
				teraz=teraz->next;
				free(del);
				continue;
			}
			else
			{
				del=zoznamVeci;
				zoznamVeci=zoznamVeci->next;
				free(del);
				teraz=teraz->next;
				continue;
			}
		}
		
		pred=teraz;
		teraz=teraz->next;
	}

	if(pridaj)pridajZbran();
}

void akciaVec(vec **p)
{
	vec *teraz;
	vec *pred;
	vec *del;

	pred=NULL;
	teraz=*p;

	while(teraz!=NULL)
	{
		teraz->policko++;
		if(teraz->cas>0)teraz->cas--;
		if(teraz->policko==teraz->maxPolicko*RYCHLOST_ANIMACIE)teraz->policko=0;

		if(teraz->cas==0)
		{
			pridajPrekresli(&zoznamPrekresli,teraz->x-10,
			teraz->y-10,teraz->w+10,teraz->h+10);

			if(pred!=NULL)
			{
				pred->next=teraz->next;
				del=teraz;
				teraz=teraz->next;
				free(del);
				continue;
			}
			else
			{
				del=zoznamVeci;
				zoznamVeci=zoznamVeci->next;
				free(del);
				teraz=teraz->next;
				continue;
			}
		}

		pred=teraz;
		teraz=teraz->next;
	}
}

void kresliVec(vec **p)
{
	vec *teraz;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		pridajImage(&zoznamImage,teraz->g,teraz->x,teraz->y,
		teraz->w,teraz->h,teraz->w*(teraz->policko/RYCHLOST_ANIMACIE),0,teraz->w,teraz->h,1,1);

		teraz=teraz->next;
	}
}

void quitVec(vec **p)
{
	vec *teraz;
	vec *del;

	teraz=*p;
	
	while(teraz!=NULL)
	{
		del=teraz;	
		teraz=teraz->next;
		free(del);
	}

	//zoznamVeci=NULL;
	*p=NULL;
}
