
#include "interface.h"
#include "suborLevel.h"
#include "bulanec.h"
#include "hraSa.h"
#include "widget_button.h"
#include "widget_label.h"
#include "kurzor.h"
#include "jazyk.h"
#include "vyberLevel.h"

static SDL_Surface *g_tapeta;
//static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

static SDL_Surface **g_level;
static SDL_Surface **g_level_shadow;

static wid_button *cudlikStart;
static wid_button *cudlikSpat;
static wid_label **napis;

static SDL_Surface *g_hore;
static SDL_Surface *g_dole;

static int vyber;
static int posuvatko;
static int mozeKliknut;

void initVyberLevel()
{
	unsigned strl1 = strlen(PATH_IMAGE);
	char * str = malloc(strl1+STR_SIZE);
	char *nazov;
	int i;

	g_tapeta = loadImage(PATH_IMAGE "vyber_level.png",0);

	g_hore = loadImage(PATH_IMAGE "hore.png",0);
	g_dole = loadImage(PATH_IMAGE "dole.png",0);

	cudlikStart = newButton(WINDOW_SIZE_X-300,WINDOW_SIZE_Y-50,Text(TEXT_CUDLIK_START));
	cudlikSpat = newButton(190,WINDOW_SIZE_Y-50,Text(TEXT_CUDLIK_SPAT));

	vyber=1;
	posuvatko=0;
	mozeKliknut=0;

	g_level=malloc(sizeof(SDL_Surface *)*getPocetLevelov());
	g_level_shadow=malloc(sizeof(SDL_Surface *)*getPocetLevelov());
	napis=malloc(sizeof(wid_label *)*getPocetLevelov());

	memcpy(str,PATH_IMAGE,strl1);

	for(i=0;i<getPocetLevelov();i++)
	{
		sprintf(str+strl1,"level%d.png",i+1);
		g_level[i] = loadImage(str,0);
		if(g_level[i]==NULL)g_level[i]=loadImage(PATH_IMAGE "no_image.png",0);;

		sprintf(str+strl1,"level%d-shadow.png",i+1);
		g_level_shadow[i] = loadImage(str,0);
		if(g_level_shadow[i]==NULL)g_level_shadow[i]=loadImage(PATH_IMAGE "no_image-shadow.png",0);

		nazov=getNazovLevelu(i);

		switch(i%4)
		{
			case 0 :
				napis[i]=newLabel(SCREE_X_1+SCREEN_SIZE_X/2,
				SCREE_Y_1+SCREEN_SIZE_Y+VZDIALENOST_TEXTU_OD_OBRAZKA,
				LABEL_CENTER,nazov);
			break;
			case 1 :
				napis[i]=newLabel(SCREE_X_2+SCREEN_SIZE_X/2,
				SCREE_Y_2+SCREEN_SIZE_Y+VZDIALENOST_TEXTU_OD_OBRAZKA,LABEL_CENTER,
				nazov);
			break;
			case 2 :
				napis[i]=newLabel(SCREE_X_3+SCREEN_SIZE_X/2,
				SCREE_Y_3+SCREEN_SIZE_Y+VZDIALENOST_TEXTU_OD_OBRAZKA,LABEL_CENTER,
				nazov);
			break;
			case 3 :
				napis[i]=newLabel(SCREE_X_4+SCREEN_SIZE_X/2,
				SCREE_Y_4+SCREEN_SIZE_Y+VZDIALENOST_TEXTU_OD_OBRAZKA,
				LABEL_CENTER,nazov);
			break;
		}
	}

	free(str);
}

void kresliVyberLevel()
{
	SDL_Rect dst_rect;
	int i;

	dst_rect.x = 0;
	dst_rect.y = 0;
	SDL_BlitSurface(g_tapeta,NULL,screen, &dst_rect);

	for(i=posuvatko*4;i<posuvatko*4+4 && i<getPocetLevelov();i++)
	{
		switch(i%4)
		{
			case 0 :
				dst_rect.x=SCREE_X_1;
				dst_rect.y=SCREE_Y_1;
			break;
			case 1 :
				dst_rect.x=SCREE_X_2;
				dst_rect.y=SCREE_Y_2;
			break;
			case 2 :
				dst_rect.x=SCREE_X_3;
				dst_rect.y=SCREE_Y_3;
			break;
			case 3 :
				dst_rect.x=SCREE_X_4;
				dst_rect.y=SCREE_Y_4;
			break;
		}

		SDL_BlitSurface((vyber==i+1?g_level[i]:g_level_shadow[i]),NULL,screen, &dst_rect);
		kresliLabel(napis[i]);
	}

	if(posuvatko>0)
	{
		dst_rect.x = POSUVATKO_HORE_X;
		dst_rect.y = POSUVATKO_HORE_Y;
		SDL_BlitSurface(g_hore,NULL,screen, &dst_rect);
	}

	if(posuvatko*4+4<getPocetLevelov())
	{
		dst_rect.x = POSUVATKO_DOLE_X;
		dst_rect.y = POSUVATKO_DOLE_Y;
		SDL_BlitSurface(g_dole,NULL,screen, &dst_rect);
	}

	kresliButton(cudlikStart);
	kresliButton(cudlikSpat);

	kresliKurzor();

	pridajPrekresli(&zoznamPrekresli,0,0,WINDOW_SIZE_X,WINDOW_SIZE_Y);
}

void akciaVyberLevel()
{
	int x,y;

	akciaButton();

	if(mozeKliknut>0)mozeKliknut--;

	SDL_GetMouseState(&x,&y);

	if(getPocetLevelov()>=posuvatko*4+1 &&
	  x>SCREE_X_1 && y>SCREE_Y_1 && x<SCREE_X_1+SCREEN_SIZE_X && y<SCREE_Y_1+SCREEN_SIZE_Y)
	{
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))vyber=1+posuvatko*4;
	}

	if(getPocetLevelov()>=posuvatko*4+2 && 
	   x>SCREE_X_2 && y>SCREE_Y_2 && x<SCREE_X_2+SCREEN_SIZE_X && y<SCREE_Y_2+SCREEN_SIZE_Y)
	{
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))vyber=2+posuvatko*4;
	}

	if(getPocetLevelov()>=posuvatko*4+3 && 
	   x>SCREE_X_3 && y>SCREE_Y_3 && x<SCREE_X_3+SCREEN_SIZE_X && y<SCREE_Y_3+SCREEN_SIZE_Y)
	{
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))vyber=3+posuvatko*4;
	}

	if(getPocetLevelov()>=posuvatko*4+4 &&
	   x>SCREE_X_4 && y>SCREE_Y_4 && x<SCREE_X_4+SCREEN_SIZE_X && y<SCREE_Y_4+SCREEN_SIZE_Y)
	{
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))vyber=4+posuvatko*4;
	}

	if(posuvatko>0 &&
	   x>POSUVATKO_HORE_X && y>POSUVATKO_HORE_Y &&
	   x<POSUVATKO_HORE_X+SIPKA_SIZE_X && y<POSUVATKO_HORE_Y+SIPKA_SIZE_Y)
	{
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))
		{
			if(mozeKliknut==0)posuvatko--;
			mozeKliknut=10;
		}
	}

	if(posuvatko*4+4<getPocetLevelov() &&
	   x>POSUVATKO_DOLE_X && y>POSUVATKO_DOLE_Y && 
	   x<POSUVATKO_DOLE_X+SIPKA_SIZE_X && y<POSUVATKO_DOLE_Y+SIPKA_SIZE_Y)
	{
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))
		{
			if(mozeKliknut==0)posuvatko++;
			mozeKliknut=10;
		}
	}

	if(isKlik(cudlikStart)==1)
	{
		char *str = malloc(strlen(PATH_DATA)+STR_SIZE);

#ifdef NET_MULTIPLAYER
		initNetworkGame(vyber);
#endif
		nacitajLevel((char **)zdrojakyLevelov[vyber-1]);

		setMiesto_v_hre(HRA_SA);

		free(str);
	}

	if(isKlik(cudlikSpat)==1)setMiesto_v_hre(MAIN_MENU);
}

void quitVyberLevel()
{
	int i;

	SDL_FreeSurface(g_tapeta);
	SDL_FreeSurface(g_hore);
	SDL_FreeSurface(g_dole);

	for(i=0;i<getPocetLevelov();i++)
	{
		SDL_FreeSurface(g_level[i]);
		SDL_FreeSurface(g_level_shadow[i]);
		destroyLabel(napis[i]);
	}

	free(g_level);
	free(g_level_shadow);

	destroyButton(cudlikStart);
	destroyButton(cudlikSpat);
}
