
#include "interface.h"
#include "widget_button.h"

static SDL_Surface *g_button0;
static SDL_Surface *g_button1;

static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

static int casKliku;

void initButton()
{
	g_button0 = loadImage(PATH_IMAGE "button0.png",1);
	g_button1 = loadImage(PATH_IMAGE "button1.png",1);
	casKliku=0;
}

wid_button* newButton(int x,int y,char *s)
{

	wid_button *teraz;
	teraz = malloc(sizeof(wid_button));
	teraz->x=x;
	teraz->y=y;
	teraz->napis=s;
	teraz->klik=0;
	return teraz;
}

void destroyButton(wid_button *p)
{
	free(p);
}

void kresliButton(wid_button *p)
{
	SDL_Rect dst_rect;
	SDL_Surface *text;
	int width;
	int active=0;
	int x,y;	

	SDL_GetMouseState(&x,&y);

	if(x>p->x && y>p->y && x<p->x+BUTTON_SIZE_X && y<p->y+BUTTON_SIZE_Y)
	{
		active=1;	
		if(SDL_GetMouseState(NULL,NULL) & SDL_BUTTON(SDL_BUTTON_LEFT))p->klik=1;
	}

	dst_rect.x=p->x;
	dst_rect.y=p->y;

	SDL_BlitSurface((active==1?g_button1:g_button0),NULL,screen, &dst_rect);
	pridajPrekresli(&zoznamPrekresli,p->x-10,p->y-10,BUTTON_SIZE_X+20,BUTTON_SIZE_X+20);


	TTF_SizeText(g_font,p->napis,&width,NULL);
	text = TTF_RenderUTF8_Blended(g_font,p->napis,farba_pisma);
	dst_rect.x = p->x+(BUTTON_SIZE_X-width)/2;
#ifdef WIN32
	dst_rect.y = p->y+3+(BUTTON_SIZE_Y-TTF_FontHeight(g_font))/2;
#else
	dst_rect.y = p->y+(BUTTON_SIZE_Y-TTF_FontHeight(g_font))/2;
#endif
	SDL_BlitSurface(text,NULL,screen,&dst_rect);
	SDL_FreeSurface(text);
}

void akciaButton()
{
	if(casKliku>0)casKliku--;
}

int isKlik(wid_button *p)
{
	int ret;
	
	ret=p->klik;
	p->klik=0;	
	if(casKliku!=0)return 0;
	if(ret==1)casKliku=10;
	return ret;
}

void quitButton()
{
	SDL_FreeSurface(g_button0);
	SDL_FreeSurface(g_button1);
}

