
#include "interface.h"
#include "widget_textfield.h"

static SDL_Surface *g_textfield0;
static SDL_Surface *g_textfield1;

static SDL_Color farba_pisma = {255,255,255,0};// Barva textu

void initTextfield()
{
	g_textfield0 = loadImage(PATH_IMAGE "button0.png",1);
	g_textfield1 = loadImage(PATH_IMAGE "button1.png",1);
}

wid_textfield* newTextfield(int x,int y,char *s)
{
	wid_textfield *teraz;
	teraz = malloc(sizeof(wid_textfield));
	teraz->x=x;
	teraz->y=y;
	strcpy(teraz->napis,s);
	teraz->active=0;
	teraz->pis=0;
	teraz->blik=0;
	return teraz;
}

void destroyTextfield(wid_textfield *p)
{
	free(p);
}

void kresliTextfield(wid_textfield *p)
{
	SDL_Rect dst_rect;
	SDL_Surface *text;
	char str[STR_SIZE];
	int width;
	
	dst_rect.x=p->x;
	dst_rect.y=p->y;

	SDL_BlitSurface((p->active==1?g_textfield1:g_textfield0),NULL,screen, &dst_rect);
	pridajPrekresli(&zoznamPrekresli,p->x-10,p->y-10,TEXTFIELD_SIZE_X+20,TEXTFIELD_SIZE_Y+20);

	strcpy(str,p->napis);
	if(p->active==1 && p->blik<5)sprintf(str,"%s>",p->napis);
	if(++p->blik==10)p->blik=0;

	TTF_SizeText(g_font,str,&width,NULL);
	text = TTF_RenderUTF8_Blended(g_font,str,farba_pisma);
	dst_rect.x = p->x+10;
#ifdef WIN32
	dst_rect.y = p->y+3+(TEXTFIELD_SIZE_X-TTF_FontHeight(g_font))/2;
#else
	dst_rect.y = p->y+(TEXTFIELD_SIZE_Y-TTF_FontHeight(g_font))/2;
#endif
	SDL_BlitSurface(text,NULL,screen,&dst_rect);
	SDL_FreeSurface(text);
}

void akciaTextfield(wid_textfield *p)
{
	int x,y,i;
	int len;
	Uint8 *mapa;
	char klavesa[2];
	
	if(SDL_GetMouseState(&x,&y) & SDL_BUTTON(SDL_BUTTON_LEFT))
	{
		if(x>p->x && y>p->y && x<p->x+TEXTFIELD_SIZE_X && y<p->y+TEXTFIELD_SIZE_Y)
			p->active=1;
		else
			p->active=0;
	}

	if(p->pis>0)p->pis--;
	if(p->active==0 || p->pis>0)return;

	mapa=SDL_GetKeyState(NULL);
	len=strlen(p->napis);

	//mazanie posledneho klavesu
	if(mapa[SDLK_BACKSPACE]==SDL_PRESSED)
	{
		p->pis=5;
		if(len>0)p->napis[len-1]='\0';
		return;
	}

	//klavesy abecedy
	for(i=SDLK_a;i<=SDLK_z;i++)
	{
		if(len<9 && mapa[i]==SDL_PRESSED)
		{
			p->pis=5;
			strcat(p->napis,SDL_GetKeyName(i));
			
			if(mapa[SDLK_LSHIFT]==SDL_PRESSED ||
			   mapa[SDLK_RSHIFT]==SDL_PRESSED)
			{
				p->napis[strlen(p->napis)-1]-=32;
			}
		}
	}

	// aby ve jmene bulanka fungovaly take cislice alfanumericke klavesnice
	for(i=SDLK_0;i<=SDLK_9;i++)
	{
		if(len<9 && mapa[i]==SDL_PRESSED)
		{
			p->pis=5;
			strcat(p->napis, SDL_GetKeyName(i));
		}
	}
	
	// aby ve jmene bulanka fungovaly take cislice napsane na numericke klavesnici
	for(i=SDLK_KP0;i<=SDLK_KP9;i++)
	{
		if(len<9 && mapa[i]==SDL_PRESSED)
		{
			p->pis=5;
			sprintf(klavesa, "%d", i-256);
			strcat(p->napis, klavesa);
		}
	}
}

void quitTextfield()
{
	SDL_FreeSurface(g_textfield0);
	SDL_FreeSurface(g_textfield1);
}

